﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Models;

namespace Data.Interfaces
{
    public interface IRepository<T> where T : BaseModel
    {
        Task<IEnumerable<T>> GetAll(long companyId);

        Task<T> GetById(long id);

        Task Delete(long id);

        Task<long> Create(T model);

        Task<long> Update(T model);
    }
}

