﻿using Data.Attributes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Data.Models
{
    public class BankAccount : CompanyRelatedModel
    {
        public string NumberPrefix { get; set; }

        public string Number { get; set; }

        public string BankCode { get; set; }

        public string SWIFT { get; set; }

        public string IBAN { get; set; }

        [IgnoreDB]
        public bool IsForeign
        {
            get
            {
                return !string.IsNullOrEmpty(SWIFT) && !string.IsNullOrEmpty(IBAN);
            }
        }
    }
}
