﻿using Data.Attributes;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Data.Models
{
    public class Invoice : CompanyRelatedModel
    {
        public Invoice()
        {

        }

        public DateTimeOffset PayDate { get; set; }

        public long VendorId { get; set; }

        public string InvoiceItemsCSV { get; set; }

        public long InvoiceNumber { get; set; }

        public long BankTransactionId { get; set; } 

        public bool PayType { get; set; }

        public bool InvoiceType { get; set; }

        public long CustomerId { get; set; }

        public float TotalCost { get; set; }

        public bool PayState { get; set; }
        
        [IgnoreDB]
        public IEnumerable<InvoiceItem> InvoiceItems
        {
            get
            {
                var result = new List<InvoiceItem>();
                int i = 0;
                string key = "";
                if (InvoiceItemsCSV != null) { 
                    foreach (var item in InvoiceItemsCSV.Split('\n'))
                    {
                        if (i == 0)
                        {
                            key = item.Replace(',', ';');
                        }
                        else
                        {
                            var values = item.Split(',');
                            if (values.Length == 4) {
                                var invItem = new InvoiceItem {
                                    Desc = values[0],
                                    Quantity = values[1],
                                    Price = values[2]
                                };
                                result.Add(invItem);
                            }
                        }

                        i++;
                    }
                }

                return result;
            }

            set
            {
                //InvoiceItemsCSV = string.Join(";", value.Select(d => string.Format("{0};{1}", d.Key.Replace(';', '`'))));
            }
        }

        /*
        [IgnoreDB]
        public decimal TotalPrice
        {
            get
            {
                decimal totalPrice = 0M;
                foreach (var price in InvoiceItems.Values)
                {
                    totalPrice += totalPrice;
                }

                return totalPrice;
            }
        }*/
    }
}
