﻿using Data.Models;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using Data.Interfaces;

namespace Data.Repositories
{
    public static class BankAccountRepository
    {
        public static async Task<BankAccount> GetCompanyBankAccount(this IRepository<BankAccount> repo, long companyId, bool type)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = string.Format("SELECT bank.* FROM [Vendor] as vendor INNER JOIN [BankAccount] as bank ON (vendor.BankAccountId = bank.Id) WHERE ((vendor.CompanyId = @Id) AND (vendor.Production = @Type))");
                var item = connection.Query<BankAccount>(@command, new { Id = companyId, Type = type }).FirstOrDefault();
                return await Task.FromResult<BankAccount>(item);
            }
        }
    }
}
