﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Models;
using Data.Interfaces;
using System.Data.SqlClient;
using Dapper;

namespace Data.Repositories
{
    public static class BusinessRecordRepository
    {
        public static async Task<IEnumerable<BusinessRecord>> GetAllByType(this IRepository<BusinessRecord> baseRepo, bool type, long companyId, string from, string to)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT * FROM [BusinessRecord] WHERE Income = @type AND CompanyId = @companyId AND ((CreatedAt >= @From) AND (CreatedAt <= @To))";
                return await Task.FromResult<IEnumerable<BusinessRecord>>(connection.Query<BusinessRecord>(@command, new { type = type, companyId = companyId, From = from, To = to }));
            }
        }

        public static async Task<IEnumerable<BusinessRecord>> GetAllFromTo(this IRepository<BusinessRecord> baseRepo, long companyId, string from, string to)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT * FROM [BusinessRecord] WHERE CompanyId = @companyId AND ((CreatedAt >= @From) AND (CreatedAt <= @To))";
                return await Task.FromResult<IEnumerable<BusinessRecord>>(connection.Query<BusinessRecord>(@command, new { companyId = companyId, From = from, To = to }));
            }
        }
    }
}
