﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Models;
using Data.Interfaces;
using System.Data.SqlClient;
using Dapper;
using Data.Enums;

namespace Data.Repositories
{
    public static class HarvestedCropRepository
    {
        public static async Task<IEnumerable<HarvestedCrop>> GetByCrop(this IRepository<HarvestedCrop> baseRepo, long cropId)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT * FROM [HarvestedCrop] WHERE CropId = @cropId";
                return await Task.FromResult<IEnumerable<HarvestedCrop>>(connection.Query<HarvestedCrop>(@command, new { cropId = cropId }));
            }
        }
    }
}
