﻿using System.Linq;
using Dapper;
using System.Data.SqlClient;
using System.Threading.Tasks;
using System;
using Data.Models;
using Data.Interfaces;
using System.Collections.Generic;

namespace Data.Repositories
{
    public static class PartSoilBlockRepository
    {
        public static async Task<IEnumerable<PartSoilBlock>> GetBySoilBlock(this IRepository<PartSoilBlock> baseRepo, long idSoilBlock, long year)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT * FROM [PartSoilBlock] WHERE (SoilBlockId = @IdSoilBlock) AND (MarketingYear = @year)";
                return await Task.FromResult<IEnumerable<PartSoilBlock>>(connection.Query<PartSoilBlock>(@command, new { IdSoilBlock = idSoilBlock, year = year }));
            }
        }

        public static async Task DeleteByBlock(this IRepository<PartSoilBlock> baseRepo, long blockId)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "DELETE FROM [PartSoilBlock] WHERE SoilBlockId = @SoilBlockId";
                await Task.Run(() =>
                {
                    connection.Query(@command, new { SoilBlockId = blockId });
                });
            }
        }

        /*
        public static async Task<long> CountPartSoilBlock(this IRepository<PartSoilBlock> baseRepo, long idSoilBlock)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT COUNT(Id) FROM [PartSoilBlock] WHERE SoilBlockId = @IdSoilBlock";
                var count = connection.Query<long>(@command, new { IdSoilBlock = idSoilBlock });
                return await Task.FromResult<long>(count);
            }
        }*/
    }
}
