﻿using Data.Models;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using Data.Interfaces;

namespace Data.Repositories
{
    public static class SoilBlockRepository
    {

        public static async Task<Dictionary<long, int>> GetBlocksPartCount(this IRepository<SoilBlock> baseRepo, IEnumerable<long> ids, long year)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT SoilBlockId, count(*) As Count FROM [PartSoilBlock] WHERE (SoilBlockId In @ids) AND (MarketingYear = @year) GROUP BY SoilBlockId";
                return await Task.FromResult<Dictionary<long, int>>(connection.Query(@command, new { ids = ids, year = year}).ToDictionary(x => (long)x.SoilBlockId, y => (int)y.Count));
            }
        }
    }
}
