﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Models;
using Data.Interfaces;
using System.Data.SqlClient;
using Dapper;
using Data.Enums;

namespace Data.Repositories
{
    public static class StockItemRepository
    {
        public static async Task<IEnumerable<StockItem>> GetAllCategory(this IRepository<StockItem> baseRepo, long CategoryId, long CompanyId)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT * FROM [StockItem] WHERE CategoryId = @id AND CompanyId = @companyId";
                return await Task.FromResult<IEnumerable<StockItem>>(connection.Query<StockItem>(@command, new { id = CategoryId, companyId = CompanyId }));
            }
        }

        public static async Task<IEnumerable<StockItem>> GetCategoryByRelation(this IRepository<StockItem> baseRepo, long CategoryId, long RelationId)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT [StockItem].* FROM [StockItem] JOIN [CropRelationship] ON (StockItem.Id = CropRelationship.StockItemId) WHERE (StockItem.CategoryId = @CategoryId) AND (CropRelationship.CropId = @RelationId)";
                return await Task.FromResult<IEnumerable<StockItem>>(connection.Query<StockItem>(@command, new { CategoryId = CategoryId, RelationId = RelationId }));
            }
        }

        public static async Task<IEnumerable<StockStatus>> GetStockStatus(this IRepository<StockItem> baseRepo, long CompanyId)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT CategoryId,SUM(Quantity) as Quantity,Sum(Price) as Merit FROM [StockItem] WHERE CompanyId = @companyId GROUP BY CategoryId";
                return await Task.FromResult<IEnumerable<StockStatus>>(connection.Query<StockStatus>(@command, new { companyId = CompanyId}));
            }
        }
    }
}
