﻿using Data.Interfaces;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;

namespace Data.Repositories
{
    public static class WcatToMachineRepository
    {
        public static async Task<float> GetConsumption(this IRepository<WcatToMachine> baseRepo, long workId, long machineId)
        {
            using (SqlConnection connection = ConnectionManager.GetConnection())
            {
                connection.Open();
                string command = "SELECT AverageConsumption FROM [WcatToMachine] WHERE (WorkId = @workId) AND (MachineId = @machineId)";
                return await Task.FromResult<float>(connection.Query<float>(@command, new { workId = workId, machineId = machineId }).Single());
            }
        }
    }
}
