﻿CREATE TABLE [dbo].[Invoice]
(
	[Id] INT NOT NULL PRIMARY KEY IDENTITY(1, 1), 
	[CreatedAt] DATETIMEOFFSET NULL, 
	[CompanyId] INT NOT NULL,
    [PayDate] DATETIMEOFFSET NOT NULL, 
    [VendorId] INT NOT NULL, 
	[CustomerId] INT NOT NULL,
    [InvoiceItemsCSV] NVARCHAR(MAX) NOT NULL, 
    [InvoiceNumber] INT NOT NULL, 
    [BankTransactionId] INT NULL, 
    [PayType] BIT NOT NULL, 
    [InvoiceType] BIT NOT NULL, 
    [TotalCost] FLOAT NULL, 
    [PayState] BIT NOT NULL DEFAULT 0, 
    CONSTRAINT [FK_Invoice_ToCompanyId] FOREIGN KEY ([CompanyId]) REFERENCES [Company]([Id]),
	CONSTRAINT [FK_Invoice_ToVendorId] FOREIGN KEY ([VendorId]) REFERENCES [Vendor]([Id]),
	CONSTRAINT [FK_Invoice_ToCustomerId] FOREIGN KEY ([CustomerId]) REFERENCES [Vendor]([Id])
)
