﻿/*
Deployment script for DatabaseDP

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "DatabaseDP"
:setvar DefaultFilePrefix "DatabaseDP"
:setvar DefaultDataPath "C:\Users\ldohnalek\AppData\Local\Microsoft\VisualStudio\SSDT"
:setvar DefaultLogPath "C:\Users\ldohnalek\AppData\Local\Microsoft\VisualStudio\SSDT"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
/*
The column [dbo].[Invoice].[PayType] on table [dbo].[Invoice] must be added, but the column has no default value and does not allow NULL values. If the table contains data, the ALTER script will not work. To avoid this issue you must either: add a default value to the column, mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.
*/

IF EXISTS (select top 1 1 from [dbo].[Invoice])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
PRINT N'Rename refactoring operation with key bb1a7dce-1666-48c8-ab30-a49f52cd3e3b is skipped, element [dbo].[BankTransaction].[variableSym] (SqlSimpleColumn) will not be renamed to VariableSym';


GO
PRINT N'Rename refactoring operation with key a65ba28e-c78b-4a6a-9ee1-dd1392efc18a is skipped, element [dbo].[BankTransaction].[constSym] (SqlSimpleColumn) will not be renamed to ConstSym';


GO
PRINT N'Dropping [dbo].[FK_Invoice_ToCompanyId]...';


GO
ALTER TABLE [dbo].[Invoice] DROP CONSTRAINT [FK_Invoice_ToCompanyId];


GO
PRINT N'Dropping [dbo].[FK_Invoice_ToVendorId]...';


GO
ALTER TABLE [dbo].[Invoice] DROP CONSTRAINT [FK_Invoice_ToVendorId];


GO
PRINT N'Dropping [dbo].[FK_Invoice_ToCustomerId]...';


GO
ALTER TABLE [dbo].[Invoice] DROP CONSTRAINT [FK_Invoice_ToCustomerId];


GO
PRINT N'Starting rebuilding table [dbo].[Invoice]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Invoice] (
    [Id]                INT                IDENTITY (1, 1) NOT NULL,
    [CreatedAt]         DATETIMEOFFSET (7) NULL,
    [CompanyId]         INT                NOT NULL,
    [UpdatedAt]         DATETIMEOFFSET (7) NOT NULL,
    [PayDate]           DATETIMEOFFSET (7) NOT NULL,
    [VendorId]          INT                NOT NULL,
    [CustomerId]        INT                NOT NULL,
    [InvoiceItemsCSV]   NVARCHAR (MAX)     NOT NULL,
    [InvoiceNumber]     INT                NOT NULL,
    [BankTransactionId] INT                NULL,
    [PayType]           BIT                NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Invoice])
    BEGIN
        SET IDENTITY_INSERT [dbo].[tmp_ms_xx_Invoice] ON;
        INSERT INTO [dbo].[tmp_ms_xx_Invoice] ([Id], [CompanyId], [UpdatedAt], [PayDate], [VendorId], [CustomerId], [InvoiceItemsCSV], [InvoiceNumber])
        SELECT   [Id],
                 [CompanyId],
                 [UpdatedAt],
                 [PayDate],
                 [VendorId],
                 [CustomerId],
                 [InvoiceItemsCSV],
                 [InvoiceNumber]
        FROM     [dbo].[Invoice]
        ORDER BY [Id] ASC;
        SET IDENTITY_INSERT [dbo].[tmp_ms_xx_Invoice] OFF;
    END

DROP TABLE [dbo].[Invoice];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Invoice]', N'Invoice';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creating [dbo].[BankTransaction]...';


GO
CREATE TABLE [dbo].[BankTransaction] (
    [Id]                    INT                NOT NULL,
    [CreatedAt]             DATETIMEOFFSET (7) NULL,
    [VendorBankAccountId]   NCHAR (100)        NOT NULL,
    [CustomerBankAccountId] NCHAR (100)        NOT NULL,
    [VariableSym]           INT                NULL,
    [ConstSym]              INT                NULL,
    [TotalCost]             FLOAT (53)         NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[FK_Invoice_ToCompanyId]...';


GO
ALTER TABLE [dbo].[Invoice] WITH NOCHECK
    ADD CONSTRAINT [FK_Invoice_ToCompanyId] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Invoice_ToVendorId]...';


GO
ALTER TABLE [dbo].[Invoice] WITH NOCHECK
    ADD CONSTRAINT [FK_Invoice_ToVendorId] FOREIGN KEY ([VendorId]) REFERENCES [dbo].[Vendor] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Invoice_ToCustomerId]...';


GO
ALTER TABLE [dbo].[Invoice] WITH NOCHECK
    ADD CONSTRAINT [FK_Invoice_ToCustomerId] FOREIGN KEY ([CustomerId]) REFERENCES [dbo].[Vendor] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Invoice_ToBankTransaction]...';


GO
ALTER TABLE [dbo].[Invoice] WITH NOCHECK
    ADD CONSTRAINT [FK_Invoice_ToBankTransaction] FOREIGN KEY ([BankTransactionId]) REFERENCES [dbo].[BankTransaction] ([Id]);


GO
-- Refactoring step to update target server with deployed transaction logs
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'bb1a7dce-1666-48c8-ab30-a49f52cd3e3b')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('bb1a7dce-1666-48c8-ab30-a49f52cd3e3b')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'a65ba28e-c78b-4a6a-9ee1-dd1392efc18a')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('a65ba28e-c78b-4a6a-9ee1-dd1392efc18a')

GO

GO
/*
Post-Deployment Script Template							
--------------------------------------------------------------------------------------
 This file contains SQL statements that will be appended to the build script.		
 Use SQLCMD syntax to include a file in the post-deployment script.			
 Example:      :r .\myfile.sql								
 Use SQLCMD syntax to reference a variable in the post-deployment script.		
 Example:      :setvar TableName MyTable							
               SELECT * FROM [$(TableName)]					
--------------------------------------------------------------------------------------
*/

/* 
SET IDENTITY_INSERT [Role] ON;
SET IDENTITY_INSERT [Role] OFF; 
*/
GO

GO
PRINT N'Checking existing data against newly created constraints';


GO
USE [$(DatabaseName)];


GO
ALTER TABLE [dbo].[Invoice] WITH CHECK CHECK CONSTRAINT [FK_Invoice_ToCompanyId];

ALTER TABLE [dbo].[Invoice] WITH CHECK CHECK CONSTRAINT [FK_Invoice_ToVendorId];

ALTER TABLE [dbo].[Invoice] WITH CHECK CHECK CONSTRAINT [FK_Invoice_ToCustomerId];

ALTER TABLE [dbo].[Invoice] WITH CHECK CHECK CONSTRAINT [FK_Invoice_ToBankTransaction];


GO
PRINT N'Update complete.';


GO
