﻿/*
Deployment script for DatabaseDP

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "DatabaseDP"
:setvar DefaultFilePrefix "DatabaseDP"
:setvar DefaultDataPath "C:\Users\ldohnalek\AppData\Local\Microsoft\VisualStudio\SSDT"
:setvar DefaultLogPath "C:\Users\ldohnalek\AppData\Local\Microsoft\VisualStudio\SSDT"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [master];


GO

IF (DB_ID(N'$(DatabaseName)') IS NOT NULL) 
BEGIN
    ALTER DATABASE [$(DatabaseName)]
    SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
    DROP DATABASE [$(DatabaseName)];
END

GO
PRINT N'Creating $(DatabaseName)...'
GO
CREATE DATABASE [$(DatabaseName)]
    ON 
    PRIMARY(NAME = [$(DatabaseName)], FILENAME = N'$(DefaultDataPath)$(DefaultFilePrefix)_Primary.mdf')
    LOG ON (NAME = [$(DatabaseName)_log], FILENAME = N'$(DefaultLogPath)$(DefaultFilePrefix)_Primary.ldf') COLLATE SQL_Latin1_General_CP1_CI_AS
GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET ANSI_NULLS ON,
                ANSI_PADDING ON,
                ANSI_WARNINGS ON,
                ARITHABORT ON,
                CONCAT_NULL_YIELDS_NULL ON,
                NUMERIC_ROUNDABORT OFF,
                QUOTED_IDENTIFIER ON,
                ANSI_NULL_DEFAULT ON,
                CURSOR_DEFAULT LOCAL,
                CURSOR_CLOSE_ON_COMMIT OFF,
                AUTO_CREATE_STATISTICS ON,
                AUTO_SHRINK OFF,
                AUTO_UPDATE_STATISTICS ON,
                RECURSIVE_TRIGGERS OFF 
            WITH ROLLBACK IMMEDIATE;
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_CLOSE OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET ALLOW_SNAPSHOT_ISOLATION OFF;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET READ_COMMITTED_SNAPSHOT OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_UPDATE_STATISTICS_ASYNC OFF,
                PAGE_VERIFY NONE,
                DATE_CORRELATION_OPTIMIZATION OFF,
                DISABLE_BROKER,
                PARAMETERIZATION SIMPLE,
                SUPPLEMENTAL_LOGGING OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF IS_SRVROLEMEMBER(N'sysadmin') = 1
    BEGIN
        IF EXISTS (SELECT 1
                   FROM   [master].[dbo].[sysdatabases]
                   WHERE  [name] = N'$(DatabaseName)')
            BEGIN
                EXECUTE sp_executesql N'ALTER DATABASE [$(DatabaseName)]
    SET TRUSTWORTHY OFF,
        DB_CHAINING OFF 
    WITH ROLLBACK IMMEDIATE';
            END
    END
ELSE
    BEGIN
        PRINT N'The database settings cannot be modified. You must be a SysAdmin to apply these settings.';
    END


GO
IF IS_SRVROLEMEMBER(N'sysadmin') = 1
    BEGIN
        IF EXISTS (SELECT 1
                   FROM   [master].[dbo].[sysdatabases]
                   WHERE  [name] = N'$(DatabaseName)')
            BEGIN
                EXECUTE sp_executesql N'ALTER DATABASE [$(DatabaseName)]
    SET HONOR_BROKER_PRIORITY OFF 
    WITH ROLLBACK IMMEDIATE';
            END
    END
ELSE
    BEGIN
        PRINT N'The database settings cannot be modified. You must be a SysAdmin to apply these settings.';
    END


GO
ALTER DATABASE [$(DatabaseName)]
    SET TARGET_RECOVERY_TIME = 0 SECONDS 
    WITH ROLLBACK IMMEDIATE;


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET FILESTREAM(NON_TRANSACTED_ACCESS = OFF),
                CONTAINMENT = NONE 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_CREATE_STATISTICS ON(INCREMENTAL = OFF),
                MEMORY_OPTIMIZED_ELEVATE_TO_SNAPSHOT = OFF,
                DELAYED_DURABILITY = DISABLED 
            WITH ROLLBACK IMMEDIATE;
    END


GO
USE [$(DatabaseName)];


GO
IF fulltextserviceproperty(N'IsFulltextInstalled') = 1
    EXECUTE sp_fulltext_database 'enable';


GO
PRINT N'Creating [dbo].[Address]...';


GO
CREATE TABLE [dbo].[Address] (
    [Id]        INT                IDENTITY (1, 1) NOT NULL,
    [City]      NVARCHAR (MAX)     NULL,
    [Street]    NVARCHAR (MAX)     NULL,
    [Psc]       INT                NULL,
    [Cp]        INT                NULL,
    [CreatedAt] DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[BankAccount]...';


GO
CREATE TABLE [dbo].[BankAccount] (
    [Id]             INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]      INT                NOT NULL,
    [NumberPrefix]   NVARCHAR (10)      NOT NULL,
    [Number]         NVARCHAR (15)      NOT NULL,
    [BankCode]       NVARCHAR (4)       NOT NULL,
    [VariableSymbol] NVARCHAR (10)      NOT NULL,
    [ConstantSymbol] NVARCHAR (10)      NOT NULL,
    [SWIFT]          NVARCHAR (11)      NOT NULL,
    [IBAN]           NVARCHAR (40)      NOT NULL,
    [CreatedAt]      DATETIMEOFFSET (7) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[BusinessRecord]...';


GO
CREATE TABLE [dbo].[BusinessRecord] (
    [Id]              INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]       INT                NOT NULL,
    [Description]     NVARCHAR (MAX)     NULL,
    [Price]           FLOAT (53)         NULL,
    [Quantity]        FLOAT (53)         NULL,
    [CreatedAt]       DATETIMEOFFSET (7) NULL,
    [CategoryId]      INT                NULL,
    [Name]            NCHAR (75)         NULL,
    [MeasureId]       INT                NULL,
    [VendorId]        INT                NOT NULL,
    [StockItemId]     INT                NULL,
    [Income]          BIT                NULL,
    [HarvestedItemId] INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Category]...';


GO
CREATE TABLE [dbo].[Category] (
    [Id]          INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]   INT                NOT NULL,
    [Name]        NVARCHAR (MAX)     NULL,
    [Desctiption] NVARCHAR (MAX)     NULL,
    [CreatedAt]   DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Company]...';


GO
CREATE TABLE [dbo].[Company] (
    [Id]            INT                IDENTITY (1, 1) NOT NULL,
    [Name]          NVARCHAR (MAX)     NULL,
    [Ico]           INT                NOT NULL,
    [Dic]           NVARCHAR (35)      NOT NULL,
    [AdderessId]    INT                NOT NULL,
    [ContactId]     INT                NOT NULL,
    [CreatedAt]     DATETIMEOFFSET (7) NOT NULL,
    [BankAccountId] INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Contact]...';


GO
CREATE TABLE [dbo].[Contact] (
    [Id]          INT                IDENTITY (1, 1) NOT NULL,
    [PhoneNumber] INT                NULL,
    [Email]       NVARCHAR (MAX)     NULL,
    [Fax]         INT                NULL,
    [CreatedAt]   DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[CostPlan]...';


GO
CREATE TABLE [dbo].[CostPlan] (
    [Id]               INT                IDENTITY (1, 1) NOT NULL,
    [StockItemId]      INT                NOT NULL,
    [DateCreate]       DATETIMEOFFSET (7) NULL,
    [Status]           BIT                NULL,
    [AnticipatedCosts] FLOAT (53)         NULL,
    [ActualCosts]      FLOAT (53)         NULL,
    [Dosage]           FLOAT (53)         NULL,
    [CreatedAt]        DATETIMEOFFSET (7) NULL,
    [Quantiy]          FLOAT (53)         NULL,
    [N]                FLOAT (53)         NULL,
    [S]                FLOAT (53)         NULL,
    [K]                FLOAT (53)         NULL,
    [P]                FLOAT (53)         NULL,
    [WorkId]           INT                NULL,
    [MachineryId]      INT                NULL,
    [CrpId]            INT                NOT NULL,
    [FuelId]           INT                NULL,
    [DateApplication]  DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Crop]...';


GO
CREATE TABLE [dbo].[Crop] (
    [Id]          INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]   INT                NOT NULL,
    [Name]        NVARCHAR (MAX)     NULL,
    [Description] NVARCHAR (MAX)     NULL,
    [CreatedAt]   DATETIMEOFFSET (7) NULL,
    [N]           FLOAT (53)         NULL,
    [S]           FLOAT (53)         NULL,
    [P]           FLOAT (53)         NULL,
    [K]           FLOAT (53)         NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[CropItem]...';


GO
CREATE TABLE [dbo].[CropItem] (
    [Id]                 INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]          INT                NOT NULL,
    [CropId]             INT                NOT NULL,
    [Quantity]           FLOAT (53)         NULL,
    [CreatedAt]          DATETIMEOFFSET (7) NULL,
    [CropRotationPlanId] INT                NULL,
    [DateHarvested]      DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[CropRelationship]...';


GO
CREATE TABLE [dbo].[CropRelationship] (
    [Id]          INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]   INT                NOT NULL,
    [CropId]      INT                NOT NULL,
    [StockItemId] INT                NOT NULL,
    [CreatedAt]   DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[CropRotationPlan]...';


GO
CREATE TABLE [dbo].[CropRotationPlan] (
    [Id]              INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]       INT                NOT NULL,
    [CropId]          INT                NOT NULL,
    [PartSoilBlockId] INT                NOT NULL,
    [Costs]           FLOAT (53)         NULL,
    [AverageYield]    FLOAT (53)         NULL,
    [CreatedAt]       DATETIMEOFFSET (7) NULL,
    [DateChange]      DATETIMEOFFSET (7) NULL,
    [Description]     NVARCHAR (MAX)     NULL,
    [RealCost]        FLOAT (53)         NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[CrPlanCostPlan]...';


GO
CREATE TABLE [dbo].[CrPlanCostPlan] (
    [CropRotationPlanId] INT NOT NULL,
    [CostPlansId]        INT NOT NULL
);


GO
PRINT N'Creating [dbo].[CrPlanCostPlan].[IX_CrPlanCostPlan_CropRotationPlanId]...';


GO
CREATE CLUSTERED INDEX [IX_CrPlanCostPlan_CropRotationPlanId]
    ON [dbo].[CrPlanCostPlan]([CropRotationPlanId] ASC);


GO
PRINT N'Creating [dbo].[CrPlanCostPlan].[IX_CrPlanCostPlan_CostPlansId]...';


GO
CREATE NONCLUSTERED INDEX [IX_CrPlanCostPlan_CostPlansId]
    ON [dbo].[CrPlanCostPlan]([CostPlansId] ASC);


GO
PRINT N'Creating [dbo].[HarvestedCrop]...';


GO
CREATE TABLE [dbo].[HarvestedCrop] (
    [Id]         INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]  INT                NULL,
    [CreatedAt]  DATETIMEOFFSET (7) NULL,
    [DateChange] DATETIMEOFFSET (7) NULL,
    [Quantity]   FLOAT (53)         NULL,
    [Cost]       FLOAT (53)         NULL,
    [CropId]     INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Invoice]...';


GO
CREATE TABLE [dbo].[Invoice] (
    [Id]              INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]       INT                NOT NULL,
    [Ic]              INT                NOT NULL,
    [Dic]             NVARCHAR (30)      NOT NULL,
    [UpdatedAt]       DATETIMEOFFSET (7) NOT NULL,
    [PayDate]         DATETIMEOFFSET (7) NOT NULL,
    [VendorId]        INT                NOT NULL,
    [InvoiceItemsCSV] NVARCHAR (MAX)     NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Machinery]...';


GO
CREATE TABLE [dbo].[Machinery] (
    [Id]                  INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]           INT                NULL,
    [Name]                NVARCHAR (MAX)     NULL,
    [Description]         NVARCHAR (MAX)     NULL,
    [AvarangeConsumption] FLOAT (53)         NULL,
    [CreatedAt]           DATETIMEOFFSET (7) NULL,
    [Hours]               FLOAT (53)         NULL,
    [LicensePlate]        NVARCHAR (50)      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[PartSoilBlock]...';


GO
CREATE TABLE [dbo].[PartSoilBlock] (
    [Id]            INT                IDENTITY (1, 1) NOT NULL,
    [SoilBlockId]   INT                NULL,
    [Description]   NVARCHAR (50)      NULL,
    [CreatedAt]     DATETIMEOFFSET (7) NULL,
    [Area]          FLOAT (53)         NULL,
    [MarketingYear] INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[SoilBlock]...';


GO
CREATE TABLE [dbo].[SoilBlock] (
    [Id]                   INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]            INT                NOT NULL,
    [IdentificationNumber] INT                NULL,
    [Name]                 NVARCHAR (MAX)     NULL,
    [Area]                 FLOAT (53)         NULL,
    [CreatedAt]            DATETIMEOFFSET (7) NULL,
    [N]                    FLOAT (53)         NULL,
    [S]                    FLOAT (53)         NULL,
    [K]                    FLOAT (53)         NULL,
    [P]                    FLOAT (53)         NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[StockItem]...';


GO
CREATE TABLE [dbo].[StockItem] (
    [Id]          INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]   INT                NOT NULL,
    [Description] NVARCHAR (MAX)     NULL,
    [Price]       FLOAT (53)         NULL,
    [Quantity]    FLOAT (53)         NULL,
    [CreatedAt]   DATETIMEOFFSET (7) NULL,
    [DateChange]  DATETIMEOFFSET (7) NULL,
    [CategoryId]  INT                NULL,
    [Dosage]      NVARCHAR (10)      NOT NULL,
    [Name]        NCHAR (75)         NULL,
    [MeasureId]   INT                NULL,
    [N]           FLOAT (53)         NULL,
    [S]           FLOAT (53)         NULL,
    [P]           FLOAT (53)         NULL,
    [K]           FLOAT (53)         NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[StockItem].[IX_StockItem_Name]...';


GO
CREATE NONCLUSTERED INDEX [IX_StockItem_Name]
    ON [dbo].[StockItem]([Name] ASC);


GO
PRINT N'Creating [dbo].[User]...';


GO
CREATE TABLE [dbo].[User] (
    [Id]        INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId] INT                NOT NULL,
    [Name]      NVARCHAR (MAX)     NULL,
    [LastName]  NVARCHAR (MAX)     NULL,
    [Role]      INT                NOT NULL,
    [ContactId] INT                NOT NULL,
    [AddressId] INT                NOT NULL,
    [Password]  NVARCHAR (MAX)     NOT NULL,
    [CreatedAt] DATETIMEOFFSET (7) NULL,
    [UserName]  NVARCHAR (MAX)     NULL,
    [Counter]   INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Vendor]...';


GO
CREATE TABLE [dbo].[Vendor] (
    [Id]            INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]     INT                NOT NULL,
    [AddressId]     INT                NOT NULL,
    [ContactId]     INT                NOT NULL,
    [CreatedAt]     DATETIMEOFFSET (7) NOT NULL,
    [Ico]           INT                NOT NULL,
    [Dic]           NVARCHAR (35)      NOT NULL,
    [Name]          NVARCHAR (50)      NULL,
    [BankAccountId] INT                NULL,
    [Production]    BIT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[WcatToMachine]...';


GO
CREATE TABLE [dbo].[WcatToMachine] (
    [Id]                 INT        IDENTITY (1, 1) NOT NULL,
    [CreatedAt]          NCHAR (10) NULL,
    [AverageConsumption] NCHAR (10) NULL,
    [WorkId]             NCHAR (10) NULL,
    [MachineId]          NCHAR (10) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[WorkCategory]...';


GO
CREATE TABLE [dbo].[WorkCategory] (
    [Id]                 INT                IDENTITY (1, 1) NOT NULL,
    [CompanyId]          INT                NULL,
    [CreatedAt]          DATETIMEOFFSET (7) NULL,
    [Name]               NVARCHAR (MAX)     NULL,
    [Description]        NVARCHAR (MAX)     NULL,
    [Price]              FLOAT (53)         NULL,
    [AverageConsumption] FLOAT (53)         NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[FK_BankAccount_Company]...';


GO
ALTER TABLE [dbo].[BankAccount]
    ADD CONSTRAINT [FK_BankAccount_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_BusinessRecord_Company]...';


GO
ALTER TABLE [dbo].[BusinessRecord]
    ADD CONSTRAINT [FK_BusinessRecord_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_BusinessRecord_Vendor]...';


GO
ALTER TABLE [dbo].[BusinessRecord]
    ADD CONSTRAINT [FK_BusinessRecord_Vendor] FOREIGN KEY ([VendorId]) REFERENCES [dbo].[Vendor] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Category_Company]...';


GO
ALTER TABLE [dbo].[Category]
    ADD CONSTRAINT [FK_Category_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Company_Address]...';


GO
ALTER TABLE [dbo].[Company]
    ADD CONSTRAINT [FK_Company_Address] FOREIGN KEY ([AdderessId]) REFERENCES [dbo].[Address] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CostPlan_CropRotationPlan]...';


GO
ALTER TABLE [dbo].[CostPlan]
    ADD CONSTRAINT [FK_CostPlan_CropRotationPlan] FOREIGN KEY ([CrpId]) REFERENCES [dbo].[CropRotationPlan] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Crop_Company]...';


GO
ALTER TABLE [dbo].[Crop]
    ADD CONSTRAINT [FK_Crop_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropItem_Company]...';


GO
ALTER TABLE [dbo].[CropItem]
    ADD CONSTRAINT [FK_CropItem_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropItem_Crop]...';


GO
ALTER TABLE [dbo].[CropItem]
    ADD CONSTRAINT [FK_CropItem_Crop] FOREIGN KEY ([CropId]) REFERENCES [dbo].[Crop] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropItem_CropRotationPlan]...';


GO
ALTER TABLE [dbo].[CropItem]
    ADD CONSTRAINT [FK_CropItem_CropRotationPlan] FOREIGN KEY ([CropRotationPlanId]) REFERENCES [dbo].[CropRotationPlan] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropRelationship_Company]...';


GO
ALTER TABLE [dbo].[CropRelationship]
    ADD CONSTRAINT [FK_CropRelationship_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropRelationship_Crop]...';


GO
ALTER TABLE [dbo].[CropRelationship]
    ADD CONSTRAINT [FK_CropRelationship_Crop] FOREIGN KEY ([CropId]) REFERENCES [dbo].[Crop] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropRelationship_StockItem]...';


GO
ALTER TABLE [dbo].[CropRelationship]
    ADD CONSTRAINT [FK_CropRelationship_StockItem] FOREIGN KEY ([StockItemId]) REFERENCES [dbo].[StockItem] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropRotationPlan_Company]...';


GO
ALTER TABLE [dbo].[CropRotationPlan]
    ADD CONSTRAINT [FK_CropRotationPlan_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropRotationPlan_Crop]...';


GO
ALTER TABLE [dbo].[CropRotationPlan]
    ADD CONSTRAINT [FK_CropRotationPlan_Crop] FOREIGN KEY ([CropId]) REFERENCES [dbo].[Crop] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CropRotationPlan_PartSoilBlock]...';


GO
ALTER TABLE [dbo].[CropRotationPlan]
    ADD CONSTRAINT [FK_CropRotationPlan_PartSoilBlock] FOREIGN KEY ([PartSoilBlockId]) REFERENCES [dbo].[PartSoilBlock] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CrPlanCostPlan_CorpRotationPlan]...';


GO
ALTER TABLE [dbo].[CrPlanCostPlan]
    ADD CONSTRAINT [FK_CrPlanCostPlan_CorpRotationPlan] FOREIGN KEY ([CropRotationPlanId]) REFERENCES [dbo].[CropRotationPlan] ([Id]);


GO
PRINT N'Creating [dbo].[FK_CrPlanCostPlan_CostPlan]...';


GO
ALTER TABLE [dbo].[CrPlanCostPlan]
    ADD CONSTRAINT [FK_CrPlanCostPlan_CostPlan] FOREIGN KEY ([CostPlansId]) REFERENCES [dbo].[CostPlan] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Invoice_ToCompanyId]...';


GO
ALTER TABLE [dbo].[Invoice]
    ADD CONSTRAINT [FK_Invoice_ToCompanyId] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Invoice_ToVendorId]...';


GO
ALTER TABLE [dbo].[Invoice]
    ADD CONSTRAINT [FK_Invoice_ToVendorId] FOREIGN KEY ([VendorId]) REFERENCES [dbo].[Vendor] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Machinery_Company]...';


GO
ALTER TABLE [dbo].[Machinery]
    ADD CONSTRAINT [FK_Machinery_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_PartSoilBlock_SoilBlock]...';


GO
ALTER TABLE [dbo].[PartSoilBlock]
    ADD CONSTRAINT [FK_PartSoilBlock_SoilBlock] FOREIGN KEY ([SoilBlockId]) REFERENCES [dbo].[SoilBlock] ([Id]);


GO
PRINT N'Creating [dbo].[FK_SoilBlock_Company]...';


GO
ALTER TABLE [dbo].[SoilBlock]
    ADD CONSTRAINT [FK_SoilBlock_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_StockItem_Company]...';


GO
ALTER TABLE [dbo].[StockItem]
    ADD CONSTRAINT [FK_StockItem_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_User_Company]...';


GO
ALTER TABLE [dbo].[User]
    ADD CONSTRAINT [FK_User_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_User_Contact]...';


GO
ALTER TABLE [dbo].[User]
    ADD CONSTRAINT [FK_User_Contact] FOREIGN KEY ([ContactId]) REFERENCES [dbo].[Contact] ([Id]);


GO
PRINT N'Creating [dbo].[FK_User_Address]...';


GO
ALTER TABLE [dbo].[User]
    ADD CONSTRAINT [FK_User_Address] FOREIGN KEY ([AddressId]) REFERENCES [dbo].[Address] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Vendor_Company]...';


GO
ALTER TABLE [dbo].[Vendor]
    ADD CONSTRAINT [FK_Vendor_Company] FOREIGN KEY ([CompanyId]) REFERENCES [dbo].[Company] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Vendor_Address]...';


GO
ALTER TABLE [dbo].[Vendor]
    ADD CONSTRAINT [FK_Vendor_Address] FOREIGN KEY ([AddressId]) REFERENCES [dbo].[Address] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Vendor_Contact]...';


GO
ALTER TABLE [dbo].[Vendor]
    ADD CONSTRAINT [FK_Vendor_Contact] FOREIGN KEY ([ContactId]) REFERENCES [dbo].[Contact] ([Id]);


GO
PRINT N'Creating [dbo].[FK_Vendor_BankAccount]...';


GO
ALTER TABLE [dbo].[Vendor]
    ADD CONSTRAINT [FK_Vendor_BankAccount] FOREIGN KEY ([BankAccountId]) REFERENCES [dbo].[BankAccount] ([Id]);


GO
-- Refactoring step to update target server with deployed transaction logs

IF OBJECT_ID(N'dbo.__RefactorLog') IS NULL
BEGIN
    CREATE TABLE [dbo].[__RefactorLog] (OperationKey UNIQUEIDENTIFIER NOT NULL PRIMARY KEY)
    EXEC sp_addextendedproperty N'microsoft_database_tools_support', N'refactoring log', N'schema', N'dbo', N'table', N'__RefactorLog'
END
GO
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '01681947-0e47-4fe4-9e5d-03051c90ac4d')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('01681947-0e47-4fe4-9e5d-03051c90ac4d')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '9279254e-05cf-4afa-848c-ab6f69b4993b')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('9279254e-05cf-4afa-848c-ab6f69b4993b')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '450c4056-5a19-4745-a8a9-30e9d456e3fa')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('450c4056-5a19-4745-a8a9-30e9d456e3fa')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '0e1cc45b-0b2b-4e6c-a7ae-20f78182ece2')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('0e1cc45b-0b2b-4e6c-a7ae-20f78182ece2')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'db4ce481-20f4-4d49-9350-45c4650db616')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('db4ce481-20f4-4d49-9350-45c4650db616')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '201e24e9-9980-46b2-b4c6-d56be92c99d1')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('201e24e9-9980-46b2-b4c6-d56be92c99d1')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '7cb8e27e-d89c-4410-adbc-878c5a557585')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('7cb8e27e-d89c-4410-adbc-878c5a557585')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '05a7d8dd-b111-4df4-ba4c-0c0e3d04c7ae')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('05a7d8dd-b111-4df4-ba4c-0c0e3d04c7ae')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '18756411-56f7-4820-8433-07f7c2e350cc')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('18756411-56f7-4820-8433-07f7c2e350cc')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '52bbb139-ee50-490b-9c08-bb02cb1a33ba')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('52bbb139-ee50-490b-9c08-bb02cb1a33ba')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '4431df8a-1283-42cb-aa80-eded2cb0a6ba')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('4431df8a-1283-42cb-aa80-eded2cb0a6ba')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '4e289876-37cb-434f-b086-225443c910c2')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('4e289876-37cb-434f-b086-225443c910c2')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '0afcbd20-b220-4f1d-bfe6-4a759cb9c161')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('0afcbd20-b220-4f1d-bfe6-4a759cb9c161')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'e11e5c48-9add-4c66-a27d-a96e76910f31')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('e11e5c48-9add-4c66-a27d-a96e76910f31')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '9c88a8f9-9f88-415b-976f-7c820e595cba')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('9c88a8f9-9f88-415b-976f-7c820e595cba')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'ed2c2d03-161d-43e2-80c0-5645364e93e9')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('ed2c2d03-161d-43e2-80c0-5645364e93e9')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'fc760b00-8ce9-4ef8-bca0-5450b1a0c573')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('fc760b00-8ce9-4ef8-bca0-5450b1a0c573')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '373d2357-79e9-44db-a2ae-51d6b51dce8b')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('373d2357-79e9-44db-a2ae-51d6b51dce8b')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '74508d2a-b46c-49cf-8006-b9d6fbf90301')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('74508d2a-b46c-49cf-8006-b9d6fbf90301')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '52816469-5517-4312-98d4-feecd55ead43')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('52816469-5517-4312-98d4-feecd55ead43')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '844353e3-70da-47d1-82f8-d4bf30dd912c')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('844353e3-70da-47d1-82f8-d4bf30dd912c')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '544e16c2-287a-4f80-bce3-8df0bd318f05')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('544e16c2-287a-4f80-bce3-8df0bd318f05')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = '41c4e013-8682-424f-90bd-66607bc14147')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('41c4e013-8682-424f-90bd-66607bc14147')
IF NOT EXISTS (SELECT OperationKey FROM [dbo].[__RefactorLog] WHERE OperationKey = 'e50620e5-e8b6-43c0-b3ca-1d26a839e232')
INSERT INTO [dbo].[__RefactorLog] (OperationKey) values ('e50620e5-e8b6-43c0-b3ca-1d26a839e232')

GO

GO
/*
Post-Deployment Script Template							
--------------------------------------------------------------------------------------
 This file contains SQL statements that will be appended to the build script.		
 Use SQLCMD syntax to include a file in the post-deployment script.			
 Example:      :r .\myfile.sql								
 Use SQLCMD syntax to reference a variable in the post-deployment script.		
 Example:      :setvar TableName MyTable							
               SELECT * FROM [$(TableName)]					
--------------------------------------------------------------------------------------
*/

/* 
SET IDENTITY_INSERT [Role] ON;
SET IDENTITY_INSERT [Role] OFF; 
*/
GO

GO
DECLARE @VarDecimalSupported AS BIT;

SELECT @VarDecimalSupported = 0;

IF ((ServerProperty(N'EngineEdition') = 3)
    AND (((@@microsoftversion / power(2, 24) = 9)
          AND (@@microsoftversion & 0xffff >= 3024))
         OR ((@@microsoftversion / power(2, 24) = 10)
             AND (@@microsoftversion & 0xffff >= 1600))))
    SELECT @VarDecimalSupported = 1;

IF (@VarDecimalSupported > 0)
    BEGIN
        EXECUTE sp_db_vardecimal_storage_format N'$(DatabaseName)', 'ON';
    END


GO
PRINT N'Update complete.';


GO
