﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("Address")]
    public class AddressController : BaseController<Address,AddressViewModel>
    {
        public AddressController()
            : base(new AddressService())
        {
        }

        protected override Address ModelToData(AddressViewModel model)
        {
            return new Address
            {
                City = model.City,
                Cp = model.Cp,
                CreatedAt = model.CreatedAt,
                Id = model.Id,
                Psc = model.Psc,
                Street = model.Street
            };
        }

        protected override AddressViewModel DataToModel(Address data)
        {
            return new AddressViewModel
            {
                City = data.City,
                Cp = data.Cp,
                CreatedAt = data.CreatedAt,
                Id = data.Id,
                Psc = data.Psc,
                Street = data.Street
            };
        }
    }
}