﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("bankaccount")]
    public class BankAccountController : BaseController<BankAccount, BankAccountViewModel>
    {
        public BankAccountService Service { get; set; }

        public BankAccountController(BankAccountService service) : base(service)
        {
            Service = service;
        }

        [Route("company")]
        public async Task<BankAccount> GetCompanyBankAccount()
        {
            return await Service.GetCompanyBankAccount(IdentityHelper.CurrentUser.CompanyId, true);
        }

        protected override BankAccount ModelToData(BankAccountViewModel model)
        {
            return new BankAccount
            {
                Id = model.Id,
                CompanyId = IdentityHelper.CurrentUser.CompanyId,
                NumberPrefix = model.NumberPrefix,
                Number = model.Number,
                BankCode = model.BankCode,
                IBAN = model.IBAN ?? string.Empty,
                SWIFT = model.SWIFT ?? string.Empty
            };
        }

        protected override BankAccountViewModel DataToModel(BankAccount data)
        {
            return new BankAccountViewModel
            {
                Id = data.Id,
                //CompanyId = IdentityHelper.CurrentUser.CompanyId,
                NumberPrefix = data.NumberPrefix,
                Number = data.Number,
                BankCode = data.BankCode,
                IBAN = data.IBAN,
                SWIFT = data.SWIFT
            };
        }
    }
}
