﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("company")]
    public class CompanyController : BaseController<Company, CompanyViewModel>
    {

        public CompanyService Service { get; set; }
        
        public CompanyController(CompanyService service) 
            : base(service)
        {
            Service = service;
        }

        [Route("detail")]
        public async Task<CompanyViewModel> GetDetail()
        {
            return await Task.Run<CompanyViewModel>(() =>
            {
                var company = Service.GetById(IdentityHelper.CurrentUser.CompanyId).Result;
                return DataToModel(company);
            });
        }

        protected override Company ModelToData(CompanyViewModel model)
        {
            throw new NotImplementedException();
        }

        protected override CompanyViewModel DataToModel(Company data)
        {
            var addressService = new AddressService();
            var address = addressService.GetById(data.AdderessId).Result;
            return new CompanyViewModel
            {
                Name = data.Name,
                Ic = data.Ico,
                Dic = data.Dic.ToString(),
                City = address.City,
                Street = address.Street,
                ZipCode = address.Psc
            };

        }
    }
}
