﻿'use strict'

dpApp.controller('divideSoildBlockModalController',
    function ($scope, $timeout, $modalInstance, $location, soildBlock, marketingYear, partSoilBlockService) {
        // data
        $scope.Content = true;
        $scope.Loader = false;
        $scope.Complete = false;
        $scope.Validator = false;
        $scope.canSave = false;
        $scope.validatorMsg = "";
        $scope.partSoilBlocks = [];

        $scope.SoilBlockData = soildBlock;
        $scope.currentMarketingYear = marketingYear;

        $scope.sliderOptions = {
            from: 0,
            to: $scope.SoilBlockData.area,
            step: 0.1,
            dimension: " ha",
            css: {
                pointer: { "background-color": "grey" }
            }
        };

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.countPartSoildBlocks = function () {
            console.log($scope.numberOfPartSoildBloucks);
            if ($scope.numberOfPartSoildBloucks == undefined) {
                $scope.partSoilBlocks = [];
                $scope.validatorMsg = "Počet půdních honů musí být kladný.";
                $scope.Validator = true;
                $scope.canSave = false;
                return;
            } else {
                $scope.validatorMsg = "";
                $scope.Validator = false;

                for (var i = 0; i < $scope.numberOfPartSoildBloucks; i++) {
                    var partSoilBlockObj = {
                        index: i+1,
                        SoilBlockId: $scope.SoilBlockData.id,
                        Description: "",
                        Area: 0,
                        MarketingYear: $scope.currentMarketingYear
                    };
                    $scope.partSoilBlocks.push(partSoilBlockObj);
                };
                $scope.canSave = true;
                console.log($scope.partSoilBlocks);
            };
        };

        $scope.checkTotalArea = function () {
            var totalArea = 0;
            angular.forEach($scope.partSoilBlocks, function (value, key) {
                totalArea += value.Area;
            });
            if (totalArea > $scope.SoilBlockData.area) {
                $scope.Validator = true;
                $scope.canSave = false;
            } else {
                $scope.validatorMsg = "";
                $scope.Validator = false;
                $scope.canSave = true;
            };
        };

        $scope.save = function (data) {
            $scope.Content = false;
            $scope.Loader = true;
            console.log($scope.partSoilBlocks);
            var numberOfPartSoilBlocks = $scope.partSoilBlocks.length;
            var actualSoilBlock = 0;
            console.log("save part soil blocks", numberOfPartSoilBlocks, actualSoilBlock);

            angular.forEach($scope.partSoilBlocks, function (value, key) {
                partSoilBlockService.create(value,
                    function (data) {
                        actualSoilBlock++;
                        console.log("save part", actualSoilBlock);
                        if (actualSoilBlock == numberOfPartSoilBlocks) {
                            $scope.Complete = true;
                            $scope.Loader = false;
                            $timeout(function () {
                                $modalInstance.close();
                            }, 1500);
                        };
                    },
                    function (err) {
                        console.log("fail create part soil blocks");
                    });
            });
        }
    });