﻿'use strict'

dpApp.controller('editPartSoilBlockModalController',
    function ($scope, $rootScope, $timeout, $modalInstance, $location, soildBlock, marketingYear, partSoilBlockService) {
        $scope.Content = true;
        $scope.Loader = false;
        $scope.Complete = false;
        $scope.Validator = false;
        $scope.canSave = true;
        $scope.validatorMsg = "";
        $scope.soildBlock = soildBlock;
        $scope.currentMarketingYear = marketingYear;

        $scope.sliderOptions = {
            from: 0,
            to: $scope.soildBlock.area,
            step: 0.1,
            dimension: " ha",
            css: {
                pointer: { "background-color": "grey" }
            }
        };

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.loadPartSoilBlocks = function () {
            partSoilBlockService.partSoilBlockInfo(soildBlock.id, marketingYear,
                function (data) {
                    $scope.allPartSoilBlock = data.plain();
                    console.log("edit parts");
                    console.log($scope.allPartSoilBlock);
                },
                function (err) {
                    $scope.Validator = true;
                    $scope.canSave = false;
                    $scope.validatorMsg = "Načtení půdních honů se nezdařilo.";
                });
        };
        $scope.loadPartSoilBlocks();

        $scope.removePartSoilBlock = function (part) {
            part.delete = true;
        };

        $scope.addPartSoilBlock = function () {
            var partSoilBlockObj = {
                soilBlockId: $scope.soildBlock.id,
                description: "",
                area: 0,
                marketingYear: marketingYear,
                newPart: true
            };
            $scope.allPartSoilBlock.push(partSoilBlockObj);
        };

        $scope.checkTotalArea = function () {
            var totalArea = 0;
            angular.forEach($scope.allPartSoilBlock, function (value, key) {
                if (value.delete == undefined){
                    totalArea += value.area;
                }
            });
            if (totalArea > $scope.soildBlock.area) {
                $scope.validatorMsg = "Výměra půdních honů nesmí přesáhnout výměru půdního bloku.";
                $scope.Validator = true;
                $scope.canSave = false;
            } else {
                $scope.validatorMsg = "";
                $scope.Validator = false;
                $scope.canSave = true;
            };
        };

        $scope.saveUpdates = function () {
            var updateParts = [];
            var removeParts = [];
            $scope.Validator = false;
            
            angular.forEach($scope.allPartSoilBlock, function (value, key) {
                if (value.delete == undefined) {
                    if ((value.description == "") || (value.area <= 0)) {
                        $scope.validatorMsg = "Všechny půdní hony musí mít název a nenulovou rozlohu.";
                        $scope.Validator = true;
                    } else {
                        updateParts.push(value);
                    }
                } else {
                    if ((value.delete == true) && (value.newPart==undefined)) {
                        removeParts.push(value);
                    }
                }
            });

            if (!$scope.Validator) {
                $scope.Content = false;
                $scope.Loader = true;
                var totalUpdate = updateParts.length;
                var totalUpdateCount = 0;
                var totalRemove = removeParts.length;
                var totalRemoveCount = 0;
                angular.forEach(updateParts, function (value, key) {
                    partSoilBlockService.create(value, function (data) {
                        totalUpdateCount++;
                    }, function (err) { });
                });
                angular.forEach(removeParts, function (value, key) {
                    partSoilBlockService.delete(value.id, function (data) {
                        totalRemoveCount++;
                    }, function (err) { });
                });
                var checker = setInterval(function () {
                    if ((totalUpdateCount == totalUpdate) && (totalRemoveCount == totalRemove)) {
                        clearInterval(checker);
                        $scope.Complete = true;
                        $scope.Loader = false;
                        $timeout(function () {
                            $modalInstance.close();
                        }, 1500);
                    };
                }, 200);
            }
        };


    });