﻿'use strict'

dpApp.controller('newMachineryModalController',
    function ($scope, machineryService, $timeout, $modalInstance, $location, workCategoryService) {
        // data
        $scope.newMachineryModal = true;
        $scope.newMachineryComplete = false;
        $scope.newMachineryLoader = false;
        $scope.ModelValidator = false;
        $scope.allWork = []; // work to machinery for consumption

        $scope.machineryData = {
            id: 0,
            name: '',
            description: '',
            AvarangeConsumption: 0
        }

        workCategoryService.workInfo(function (data) {
            angular.forEach(data.plain(), function (work) {
                var workTomachinery =
                {
                    workId: work.id,
                    name: work.name,
                    price: work.price,
                    machineId: 0,
                    averageConsumption: 0
                }
                $scope.allWork.push(workTomachinery);
            });
        }, function (err) {
            console.log("Error load all work to machinery dialog ", err);
        });

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.save = function (data) {
            console.log("ulozit techniku");
            console.log(data);

            $scope.newMachineryModal = false;
            $scope.newMachineryLoader = true;
            $scope.ModelValidator = false;

            var object = {
                name: data.name,
                description: data.description,
                Hours: data.Hours,
                LicensePlate: data.LP
            }

            if (((object.name == "") || (object.name == undefined)) ||
                ((object.Hours == "") || (object.Hours == undefined)) ||
                ((object.LicensePlate == "") || (object.LicensePlate == undefined))) {
                $scope.ModelValidator = true;
                $scope.newMachineryModal = true;
                $scope.newMachineryLoader = false;
            } else {
                machineryService.create(object, $scope.allWork,
                    function (res) {
                        console.log(res);

                        $scope.newMachineryLoader = false;
                        $scope.newMachineryComplete = true;

                        $timeout(function () {
                            $modalInstance.close();
                            $location.path('/app/machineryStock');
                        }, 2000);

                    },
                    function (error) {
                        console.log(error);
                    }
                );
            };
        }
    });