﻿'use strict'

dpApp.controller('newWorkModalController',
    function ($scope, workCategoryService, $timeout, $modalInstance, machineryService) {
        // data
        $scope.newWorkModal = true;
        $scope.newWorkComplete = false;
        $scope.newWorkLoader = false;

        $scope.workData = {
            Name: '',
            Desc: '',
            Price: 0
        }



        $scope.machineryList = []; // work to machinery for consumption

        machineryService.machineryInfo(
            function (data) {
                console.log(data);
                angular.forEach(data.plain(), function (machinery) {
                    var workTomachinery =
                    {
                        workId: 0,
                        machineryName: machinery.name,
                        machineId: machinery.id,
                        averageConsumption: 0
                    }
                    $scope.machineryList.push(workTomachinery);
                });
                console.log($scope.machineryList);
            },
            function (err) {
                console.log(err);
            });

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.save = function (data) {
            console.log("ulozit techniku");
            console.log(data);

            $scope.newWorkModal = false;
            $scope.newWorkLoader = true;

            var object = {
                Name: data.Name,
                Description: data.Desc,
                Price: data.Price
            }

            workCategoryService.create(object, $scope.machineryList,
                function (res) {
                    //console.log(res);


                    $scope.newWorkLoader = false;
                    $scope.newWorkComplete = true;

                    $timeout(function () {
                        $modalInstance.close();
                        // TODO reload emit load items
                    }, 2000);

                },
                function (error) {
                    console.log(error);
                }
            );
        }
    });