﻿'use strict'

dpApp.controller('stockItemModalController',
    function ($scope, stockItemService, $modalInstance, cropService, $timeout, vendorService, addressService, contactService, $modal) {

        // data
        $scope.Modal = true;
        $scope.modalComplete = false;
        $scope.modalLoader = false;

        $scope.itemData = {
            name: '',
            desc: '',
            price: 0,
            quantity: 0,
            dosage: "",
            categoryId: 0,
            N: 0,
            S: 0,
            K: 0,
            P: 0,
            measureId: 0
        }
        $scope.selected = {};
        $scope.currenMeasure = "Zvolte";
        $scope.relation = [];

        $scope.showNewVendorModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/newVendorModal.html',
                controller: 'newVendorModalController',
                size: 1,
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });
            modalInstance.result.then(function () {
                $scope.loaadModalVendor();
            });
        }

        $scope.loadAllCrops = function () { 
        cropService.cropInfo(
                function (data) {
                    if (data.length > 0) {
                        console.log("modal service");
                        console.log(data.plain());
                        $scope.crops = data.plain();
                    }
                }, function (err) {
                    console.log("error load info about crop " + err);
                    console.log(err);
                });
        };
        $scope.loadAllCrops();

        $scope.showNewCropModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/newCropModal.html',
                controller: 'newCropModalController',
                size: 1,
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });
            modalInstance.result.then(function () {
                $scope.loadAllCrops();
            });
        };

        $scope.loaadModalVendor = function () {
            vendorService.getAll(
                function (data) {
                    console.log("dodavatele");
                    console.log(data.plain());
                    $scope.vendorSelect = data.plain();
                },
                function (err) {
                });
        }
        $scope.loaadModalVendor();

        $scope.changeVendor = function (addresId, contactId) {
            addressService.getById(addresId,
                function (data) {
                    $scope.vendorAddress = data.plain();
                },
                function (err) {
                    console.log(err);
                });
            contactService.getById(contactId,
                function (data) {
                    $scope.vendorContact = data.plain();
                },
                function (err) {
                    console.log(err);
                });
        };

        $scope.changeMeasure = function () {
            console.log($scope.itemData.stockItemMeasure);
            switch (Number($scope.itemData.stockItemMeasure)) {
                case 0:
                    $scope.currenMeasure = "Kg";
                    break;
                case 1:
                    $scope.currenMeasure = "L";
                    break;
                case 2:
                    $scope.currenMeasure = "Baleni";
                    break;
            }
        }


        // actions

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.checkRelation = function () {
            $scope.relation = [];
            angular.forEach($scope.selected, function (key, val) {
                if (key) {
                    $scope.relation.push(parseInt(val));
                };
            });
            console.log($scope.relation);
        }

        $scope.save = function (data) {

            console.log("vybrany");


            $scope.Modal = false;
            $scope.modalLoader = true;


            var object = {
                name: data.name,
                description: data.desc,
                price: data.price,
                quantity: data.quantity,
                categoryId: data.category,//data.catId
                dosage: data.dosage,
                N: data.N,
                S: data.S,
                K: data.K,
                P: data.P,
                cropRelation: $scope.relation,
                measureId: data.stockItemMeasure
            }

            var objectBusinessRecord = {
                name: data.name,
                description: data.desc,
                price: data.price,
                quantity: data.quantity,
                categoryId: data.category,
                MeasureId: 0,
                StockItemId: 0,
                VendorId: data.stockItemVendor.id,
                Income: true,
                measureId: data.stockItemMeasure
            }

            console.log(object);

            stockItemService.create(object, objectBusinessRecord,
                function (res) {
                    $scope.modalLoader = false;
                    $scope.modalComplete = true;

                    $timeout(function () {
                        $modalInstance.close();
                        // TODO reload emit load items
                    }, 2000);
                    return res;
                },
                function (error) {
                    console.log(error);
                }
            );
        }
    }
);