﻿'use strict'

//controller for html body

dpApp.controller('soilBlocksController', ['$scope', '$modal', '$log', 'soilBlockService', '$timeout', '$location','Restangular', 'confirmModalFactory','$rootScope',
    function ($scope, $modal, $log, soilBlockService, $timeout, $location, Restangular, confirmModalFactory, $rootScope) {
        console.log("soilBlocksController call route");

        $scope.newSoilBlockForm = false;
        $scope.newPartSoilBlockForm = true;
        $scope.newSoilBlockLoader = true; 
        $scope.newSoilBlockOk = true;
        $scope.infoSoilBlockLoader = false;
        $scope.currentRow = null;

        $scope.newSoilBlock = {
            "countSoilPart": 1,
            "N": 0,
            "S" : 0,
            "P" : 0,
            "K" : 0
        };

        $scope.areaCheck = false;
        $scope.years = [
          { "val": 2013, "label": "2013/2014" },
          { "val": 2014, "label": "2014/2015" },
          { "val": 2015, "label": "2015/2016" },
          { "val": 2016, "label": "2016/2017" },
          { "val": 2017, "label": "2017/2018" },
          { "val": 2018, "label": "2018/2019" },
          { "val": 2019, "label": "2019/2020" },
          { "val": 2020, "label": "2020/2021" },
          { "val": 2021, "label": "2021/2022" },
          { "val": 2022, "label": "2022/2023" },
        ];

        $scope.options = {
            from: 1,
            to: 10,
            step: 1,
            dimension: " ha",
            css: {
                pointer: { "background-color": "grey" }
            }
        };


        $scope.loadSoilBlockData = function () {
            $scope.detailSoilBlock = null;
            $scope.currentRow = null;
            soilBlockService.soilBlockInfo($rootScope.globalMarketingYear,
            function (data) {
                $scope.infoSoilBlockLoader = true;
                if (data.length > 0) {
                    $scope.soilBlockTable = data;
                } else {

                }
                console.log(data.length);
            },function (err) {
                console.log("error load info about soil blocks " + err);
                console.log(err);
            });
        }

        $scope.loadSoilBlockData();

        $rootScope.$on("updateDataChangeMarketingYear", function (e) {
            $scope.loadSoilBlockData();
        });
        
        $scope.showSoilBlockDetail = function (id, currentRow)
        {
            console.log("klik na detail soil block")
            $scope.currentRow = currentRow;
            soilBlockService.getById(id,$rootScope.globalMarketingYear,
                function (data) {
                    console.log("load soil block data ok");
                    console.log(data.plain());
                    $scope.detailSoilBlock = data.plain();
                }, function (err) {
                    console.log("err detail soilblock");
                    console.log(err);
                });
            };


        //new soil block action
        $scope.saveNewSoilBlock = function () {
            $scope.newSoilBlockLoader = false;
            $scope.newSoilBlockForm = true;

            console.log("controller save new soil block odesila");
            console.log($scope.newSoilBlock);
            $scope.partsSoilBlock = null;

            soilBlockService.saveNewSoilBlock($scope.newSoilBlock,
                function (data) {
                    console.log("new soil block");
                    console.log(data);
                    $scope.partsSoilBlock = data.plain();
                    $scope.options = {
                        from: 1,
                        to: $scope.newSoilBlock.area,
                        step: 1,
                        dimension: " ha",
                        css: {
                            pointer: { "background-color": "grey" }
                        }
                    };

                    $scope.newSoilBlockLoader = true;
                    $scope.newPartSoilBlockForm = false;
                }, function (err) {
                    console.log("error create new soil block " + err);
                }
           );
        };

        $scope.hideDetailSoilBlock = function () {
            $scope.currentRow = null;
        };

        $scope.changePartSoilBlockArea = function (newArea) {
            var totalPartSoilBlockArea = Number(0);


            angular.forEach($scope.partsSoilBlock, function (part) {
                totalPartSoilBlockArea = Number(totalPartSoilBlockArea) + Number(part.Area);
            });

            if (totalPartSoilBlockArea > $scope.newSoilBlock.area) {
                $scope.areaCheck = true;
            } else {
                $scope.areaCheck = false;
            }
        }

        $scope.savePartSoilBlock = function () {
            $scope.newPartSoilBlockForm = true;
            $scope.newSoilBlockLoader = false;
            
            soilBlockService.savePartSoilBlock($scope.partsSoilBlock, $scope.marketingYear,
                function () {
                    $scope.newPartSoilBlockForm = true;
                    $scope.newSoilBlockLoader = true;
                    $scope.newSoilBlockOk = false;

                    $timeout(function () {
                        $location.path('/app/soilBlocks');
                        $scope.newSoilBlockOk = true;
                    }, 3000);
                }, function (err) {
                    console.log("error create new part soil blocks " + err);
                }
            );
        };

        $scope.deleteSoilBlock = function (block) {

            //confirmModalFactory(1, function () {
            //    soilBlockService.delete(block, function () {
            //        console.log('reload');
            //    });
            //});
        }

        $scope.updateSoilBlock = function (block) {
            block.edit = true;
        };

        $scope.stornoUpdateSoilBlock = function () {
            $scope.loadSoilBlockData();
        };

        $scope.saveUpdateSoilBlock = function (block) {
            confirmModalFactory(1, function () {
                $scope.infoSoilBlockLoader = true;
                soilBlockService.updateSoilBlock(block,
                    function (data) {
                        $scope.infoSoilBlockLoader = false;
                        $scope.loadSoilBlockData();
                    },
                    function (err) {
                        console.log("error update soil block");
                        console.log(err);
                    });
            });
        };

        $scope.updatePartSoilBlock = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/editPartSoilBlockModal.html',
                controller: 'editPartSoilBlockModalController',
                size: 'lg',
                resolve: {
                    soildBlock: function () {
                        return $scope.detailSoilBlock;
                    },
                    marketingYear: function () {
                        return $rootScope.globalMarketingYear;
                    }
                }
            });

            modalInstance.result.then(function (newSoilBlock) {
                console.log("dialog result ok");
                $scope.loadSoilBlockData();
            }, function () {
                console.log("dialog cancel");
            });
        };

        $scope.open = function (size) {

            var modalInstance = $modal.open({
                templateUrl: 'modals/soilBlockModal.html',
                controller: 'newSoilDialogInstanceCtrl',
                size: size,
                resolve: {
                    items: function () {
                        return $scope.items;
                    }
                }
            });

            modalInstance.result.then(function (newSoilBlock) {
                $log.info("mel by ulozit " + newSoilBlock);
                $log.info(newSoilBlock);
            }, function () {
                $log.info('Modal dismissed at: ' + new Date());
            });
        };

        $rootScope.$on("updateDataChangeMarketingYear", function (e) {
            console.log("zmena roku soil block controller");
            $scope.currentRow = null;
        });

        $scope.showDivideSoildBlockDialog = function () {           
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/divideSoildBlockModal.html',
                controller: 'divideSoildBlockModalController',
                size: 'lg',
                resolve: {
                    soildBlock: function () {
                        return $scope.detailSoilBlock;
                    },
                    marketingYear: function () {
                        return $rootScope.globalMarketingYear;
                    }
                }
            });

            modalInstance.result.then(function (newSoilBlock) {
                console.log("dialog result ok");
                $scope.loadSoilBlockData();
            }, function () {
                console.log("dialog cancel");
            });
        };


}]);


// Please note that $modalInstance represents a modal window (instance) dependency.
// It is not the same as the $modal service used above.

dpApp.controller('newSoilDialogInstanceCtrl', function ($scope, $modalInstance, items) {
    /*
    $scope.newSoilBlock.name = '';
    $scope.newSoilBlock.id = '';
    $scope.newSoilBlock.area = '';*/

    $scope.save = function () {
        $modalInstance.close($scope.newSoilBlock);
    };

    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
});