﻿'use strict'

dpApp.controller('addCostItemModalController',
    function ($scope, categoryId, cropId, partSoilBlockarea, cropRotationPlanId, workCategoryService, $timeout, $modalInstance, machineryService, stockItemService, costPlanService) {
        // data
        $scope.Modal = true;
        $scope.modalComplete = false;
        $scope.modalLoader = false;
        //$scope.selectPartSoilBlockCRP.area = area;

        //-------------------------------------------------------------------------------
        $scope.item = {
            category: categoryId,
            text: "",
            date: new Date(),
            selectMaterials: $scope.selectSoilBlock,
            selectWorks: $scope.selectSoilBlock,
            selectMachines: $scope.selectSoilBlock,
            stockQuantity: 0,
            quantityMaterial: 0,
            materialCost: 0,
            workCost: 0,
            totalCost: 0,
            openStatus: true,
            addN: 0,
            addS: 0,
            addP: 0,
            addK: 0,
            consumption: 0,
            materialName: "",
            workName: "",
            machineryName: "",
            StockItemId: 0,
            WorkId: 0,
            MachineryId: 0,
            priceUnit: 0,
            needMaterial: 0,
            selectFuel: null,
            fuelId: 0,
            fuelCost: 0,
            fuelUnit: 0,
            currentMeasureName: "",
            workConsumption: 0
        };

        stockItemService.getCategoryByRelation($scope.item.category, cropId,
                function (data) {
                    $scope.item.selectMaterials = data.plain();
                    console.log("select materials");
                    console.log(data.plain());
                },
                function (err) {
                    console.log(err);
                });

        stockItemService.getAllCategory(4,
                function (data) {
                    console.log(data.plain());
                    $scope.item.selectFuel = data.plain();
                }, function (err) {
                    console.log(err);
                });

        //load work
        workCategoryService.workInfo(
            function (data) {
                $scope.item.selectWorks = data.plain();
                console.log(data.plain());
            },
            function (err) {
                console.log(err);
            });

        //load machinery
        machineryService.machineryInfo(
            function (data) {
                $scope.item.selectMachines = data.plain();
                console.log(data.plain());
            },
            function (err) {
                console.log(err);
            });

        switch ($scope.item.category) {
            case 1:
                $scope.item.text = "Osivo";
                break;
            case 2:
                $scope.item.text = "Hnojivo";
                break;
            case 3:
                $scope.item.text = "Pripravky na ochranu rostlin";
                break;
            case 0:
                $scope.item.text = "Ostatni prace";
                break;
        }

        //count cost item
        $scope.changeFuelItem = function (item, fuelItem) {
            item.fuelCost = Number(item.consumption) * (Number(fuelItem.priceUnit));
            item.totalCost = Math.round((Number(item.workCost) + Number(item.materialCost) + Number(item.fuelCost))).toFixed(2);
            item.fuelUnit = Number(fuelItem.priceUnit);
            item.fuelId = fuelItem.id;
            //$scope.countTotalCost();
        }

        $scope.changeMaterial = function (item, itemMaterial) {
            console.log("volba materialu");
            console.log(itemMaterial.id);
            item.stockQuantity = itemMaterial.quantity;
            item.materialName = itemMaterial.name;
            item.StockItemId = itemMaterial.id;
            item.currentMeasureName = itemMaterial.measureName;
            item.priceUnit = itemMaterial.priceUnit //Math.round(Number(itemMaterial.price) / Number(itemMaterial.quantity)).toFixed(2);
        }

        $scope.coutnConsumption = function (item) {

            if ((item.MachineryId > 0) && (item.WorkId > 0)) {
                console.log("machine id: " + item.MachineryId + " work id: " + item.WorkId);
                workCategoryService.getConsumption(item.WorkId, item.MachineryId,
                    function (data) {
                        console.log("spotreba");
                        console.log(data);
                        item.workConsumption = data;
                        item.consumption = Math.round(Number(partSoilBlockarea) * Number(data)).toFixed(2);
                    }, function (err) {
                        console.log(err);
                    });
            }
        }

        $scope.changeWorkItem = function (item, selectWork) {

            item.workCost = Math.round(Number(selectWork.price) * Number(partSoilBlockarea)).toFixed(2);
            console.log("cena prace " + item.workCost + " cena materialu " + item.materialCost);
            item.totalCost = Math.round((Number(item.workCost) + Number(item.materialCost) + Number(item.fuelCost))).toFixed(2);
            item.workName = selectWork.name;
            //$scope.countTotalCost();
            item.WorkId = selectWork.id;
            $scope.coutnConsumption(item);
        }

        $scope.dosageChange = function (item, itemMaterial) {
            item.quantityMaterial = Math.round(Number(item.dosage) * Number(partSoilBlockarea)).toFixed(2);
            item.materialCost = Math.round(Number(item.quantityMaterial) * (Number(item.priceUnit))).toFixed(2);
            console.log("cena prace " + item.workCost + " cena materialu " + item.materialCost);
            item.totalCost = Math.round((Number(item.workCost) + Number(item.materialCost) + Number(item.fuelCost))).toFixed(2);
            item.needMaterial = (Number(itemMaterial.quantity) - Number(item.quantityMaterial)) * (-1);
            item.addN = item.dosage * itemMaterial.n;
            item.addS = item.dosage * itemMaterial.s;
            item.addP = item.dosage * itemMaterial.p;
            item.addK = item.dosage * itemMaterial.k;


            //$scope.countTotalCost();
        }

        $scope.changeMachine = function (item, itemMachine) {
            item.machineryName = itemMachine.name;
            item.MachineryId = itemMachine.id;
            $scope.coutnConsumption(item);
        }
        //-------------------------------------------------------------------------------

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.save = function (item) {

            $scope.Modal = false;
            $scope.modalLoader = true;

            var costPlan = {
                StockItemId: Number(item.StockItemId),
                WorkId: Number(item.WorkId),
                MachineryId: Number(item.MachineryId),
                Status: false,
                AnticipatedCosts: Number(item.totalCost),
                ActualCost: 0,
                Dosage: Number(item.dosage),
                Quantiy: Number(item.quantityMaterial),
                N: Number(item.addN),
                S: Number(item.addS),
                P: Number(item.addP),
                K: Number(item.addK),
                CrpId: cropRotationPlanId,
                DateCreateTick: new Date(item.date).getTime(),
                DateCreateString: item.date,
                FuelId: Number(item.fuelId)
            }
            console.log("pridani polozky");
            console.log(costPlan);


            costPlanService.addToCropRotationPlan(costPlan,
            function (data) {
                $scope.modalLoader = false;
                $scope.modalComplete = true;
                console.log("add item ok");
                $timeout(function () {
                    $modalInstance.close();
                }, 1500);
            },
            function (err) {
                console.log(err);
            });
        }


        /*
        workCategoryService.create(object, $scope.machineryList,
            function (res) {
                //console.log(res);


                $scope.modalLoader = false;
                $scope.modalComplete = true;

                $timeout(function () {
                    $modalInstance.close();
                    // TODO reload emit load items
                }, 2000);

            },
            function (error) {
                console.log(error);
            }
        );*/
    });