﻿'use strict'

//controller for html body

dpApp.controller('newCropRotationPlanController',
    function ($scope, soilBlockService, partSoilBlockService, cropService, stockItemService, workCategoryService, machineryService, crpService, $timeout, $location, $rootScope) {
        //data

        $scope.newCRPLoader = false;
        $scope.newCRPOk = false;
        $scope.removeSubstances = {
            rN: 0,
            rS: 0,
            rP: 0,
            rK: 0
        }

        $scope.addSubstances = {
            N: 0,
            S: 0,
            P: 0,
            K: 0
        }

        $scope.CRplan = {
            CropId: 0,
            PartSoilBlockId: 0,
            Costs: 0,
            Description: ""
        };

        var costPlan = {
            StockItemId: 0,
            WorkId: 0,
            MachineryId: 0,
            Status: false,
            AnticipatedCost: 0,
            ActualCost: 0,
            Dosage: 0,
            Quantity: 0,
            N: 0,
            S: 0,
            P: 0,
            K: 0,
            CrpId: 0,
            DateCreateTick: null,
        }

        $scope.cropRotationItem = [];
        $scope.editCRP = true;


        //------------------------------------------------------------------

        //load select data
        soilBlockService.soilBlockInfo($rootScope.globalMarketingYear,
            function (data) {
                $scope.selectSoilBlock = data.plain();
                console.log(data.plain());
            }, function (err) {
                console.log("error load info about soil blocks " + err);
                console.log(err);
            });

        cropService.cropInfo(
                function (data) {
                    $scope.selectCrop = data.plain();
                }, function (err) {
                    console.log("error load info crop " + err);
                    console.log(err);
                });

        $scope.changeSoilBlock = function(soilBlockId)
        {
            partSoilBlockService.partSoilBlockInfo(soilBlockId, $rootScope.globalMarketingYear,
            function (data) {
                $scope.selectPartSoilBlock = data.plain();
                console.log(data);
            }, function (err) {
                console.log("error load info part soil block " + err);
                console.log(err);
            });
        };

        $scope.changePartSoilBlock = function()
        {
            console.log($scope.selectPartSoilBlockCRP);
            $scope.CRplan.PartSoilBlockId = $scope.selectPartSoilBlockCRP.id;
            crpService.getByYearPartSoilBlockId(2015, $scope.selectPartSoilBlockCRP.id,
                function (data) {
                    $scope.existingCrp = data.plain();
                }, function (err) {
                    console.log("error change");
                });
        }
        //-------------------------------------------------------------------

        //rotation plan action
        $scope.countSubstances = function () {
            $scope.removeSubstances = {
                rN: $scope.selectCropCRP.n,// * $scope.selectPartSoilBlockCRP.area,
                rS: $scope.selectCropCRP.s,// * $scope.selectPartSoilBlockCRP.area,
                rP: $scope.selectCropCRP.p,// * $scope.selectPartSoilBlockCRP.area,
                rK: $scope.selectCropCRP.k// * $scope.selectPartSoilBlockCRP.area
            }
            console.log($scope.selectCropCRP);
            $scope.CRplan.CropId = $scope.selectCropCRP.id;
        }

        $scope.countTotalCost = function ()
        {
            var totalCost = 0;
            angular.forEach($scope.cropRotationItem, function (item) {
                console.log("count total cost " + Number(item.totalCost));
                totalCost += Number(item.totalCost);
            });
            $scope.CRplan.Costs = totalCost;
            console.log($scope.CRplan.Costs);
        }

        $scope.addCrpItem = function (item)
        {
            var CrpItem = {
                category : item,
                text: "",
                date: new Date(),
                selectMaterials: $scope.selectSoilBlock,
                selectWorks: $scope.selectSoilBlock,
                selectMachines: $scope.selectSoilBlock,
                stockQuantity: 0,
                quantityMaterial: 0,
                materialCost: 0,
                workCost: 0,
                totalCost: 0,
                openStatus: true,
                addN: 0,
                addS: 0,
                addP: 0,
                addK: 0,
                consumption: 0,
                materialName: "",
                workName: "",
                machineryName: "",
                StockItemId: 0,
                WorkId: 0,
                MachineryId: 0,
                priceUnit: 0,
                needMaterial: 0,
                selectFuel: null,
                fuelId: 0,
                fuelCost: 0,
                fuelUnit: 0,
                currentMeasureName: "",
                workConsumption: 0
            };

            console.log("volani vypisu catId " + CrpItem.category + "cropId " + $scope.selectCropCRP.id);
            console.log($scope.selectCropCRP);
            //load material
            stockItemService.getCategoryByRelation(CrpItem.category, $scope.selectCropCRP.id,
                function (data) {
                    CrpItem.selectMaterials = data.plain();
                    console.log("select materials");
                    console.log(data.plain());
                },
                function (err) {
                    console.log(err);
                });

            //load gas
            stockItemService.getAllCategory(4,
                function (data) {
                    console.log(data.plain());
                    CrpItem.selectFuel = data.plain();
                }, function (err) {
                    console.log(err);
                });

            //load work
            workCategoryService.workInfo(
                function (data) {
                    CrpItem.selectWorks = data.plain();
                    console.log(data.plain());
                },
                function (err) {
                    console.log(err);
                });


            //load machinery
            machineryService.machineryInfo(
                function (data) {
                    CrpItem.selectMachines = data.plain();
                    console.log(data.plain());
                },
                function (err) {
                    console.log(err);
                });

            switch(item){
                case 1:
                    CrpItem.text = "Osivo";
                    break;
                case 2:
                    CrpItem.text = "Hnojivo";
                    break;
                case 3:
                    CrpItem.text = "Pripravky na ochranu rostlin";
                    break;
                case 0:
                    CrpItem.text = "Ostatni prace";
                    break;
            }
            $scope.cropRotationItem.push(CrpItem);
            console.log("pripravek");
            console.log($scope.cropRotationItem);
        }

        $scope.popCrpItem = function(index)
        {
            $scope.cropRotationItem.splice(index, 1);
            $scope.countTotalCost();
        }

        $scope.changeFuelItem = function (item, fuelItem)
        {
            item.fuelCost = Number(item.consumption) * (Number(fuelItem.priceUnit));
            item.totalCost = Math.round((Number(item.workCost) + Number(item.materialCost) + Number(item.fuelCost))).toFixed(2);
            item.fuelUnit = Number(fuelItem.priceUnit);
            item.fuelId = fuelItem.id;
            $scope.countTotalCost();
        }

        $scope.changeMaterial = function (item, itemMaterial)
        {
            console.log("volba materialu");
            console.log(itemMaterial.id);
            item.stockQuantity = itemMaterial.quantity;
            item.materialName = itemMaterial.name;
            item.StockItemId = itemMaterial.id;
            item.currentMeasureName = itemMaterial.measureName;
            item.priceUnit = itemMaterial.priceUnit //Math.round(Number(itemMaterial.price) / Number(itemMaterial.quantity)).toFixed(2);
        }

        $scope.coutnConsumption = function (item) {
            
            if ((item.MachineryId > 0) && (item.WorkId > 0)) {
                console.log("machine id: " + item.MachineryId + " work id: " + item.WorkId);
                workCategoryService.getConsumption(item.WorkId, item.MachineryId,
                    function (data) {
                        console.log("spotreba");
                        console.log(data);
                        item.workConsumption = data;
                        item.consumption = Math.round(Number($scope.selectPartSoilBlockCRP.area) * Number(data)).toFixed(2);
                    }, function (err) {
                        console.log(err);
                    });
            }
        }

        $scope.changeWorkItem = function (item,selectWork)
        {
            
            item.workCost = Math.round(Number(selectWork.price) * Number($scope.selectPartSoilBlockCRP.area)).toFixed(2);
            console.log("cena prace " + item.workCost + " cena materialu " + item.materialCost);
            item.totalCost = Math.round((Number(item.workCost) + Number(item.materialCost) + Number(item.fuelCost))).toFixed(2);
            item.workName = selectWork.name;
            $scope.countTotalCost();
            item.WorkId = selectWork.id;
            $scope.coutnConsumption(item);
        }

        $scope.dosageChange = function (item, itemMaterial)
        {
            item.quantityMaterial = Math.round(Number(item.dosage) * Number($scope.selectPartSoilBlockCRP.area)).toFixed(2);
            item.materialCost = Math.round(Number(item.quantityMaterial) * (Number(item.priceUnit))).toFixed(2);
            console.log("cena prace " + item.workCost + " cena materialu " + item.materialCost);
            item.totalCost = Math.round((Number(item.workCost) + Number(item.materialCost) + Number(item.fuelCost))).toFixed(2);
            item.needMaterial = (Number(itemMaterial.quantity) - Number(item.quantityMaterial))*(-1);
            item.addN = item.dosage * itemMaterial.n;
            item.addS = item.dosage * itemMaterial.s;
            item.addP = item.dosage * itemMaterial.p;
            item.addK = item.dosage * itemMaterial.k;

            
            $scope.countTotalCost();
        }

        $scope.changeMachine = function (item, itemMachine)
        {
            item.machineryName = itemMachine.name;
            item.MachineryId = itemMachine.id;
            $scope.coutnConsumption(item);
        }
        //---------------------------------------------------------------------

        //control action
        $scope.backSaveCRP = function ()
        {
            $scope.editCRP = true;
            $scope.showControlCRP = false;
        }

        $scope.controlCRP = function ()
        {
            $scope.editCRP = false;
            
            $scope.addSubstances.N = 0;
            $scope.addSubstances.S = 0;
            $scope.addSubstances.P = 0;
            $scope.addSubstances.K = 0;
            angular.forEach($scope.cropRotationItem, function (item) {
                $scope.addSubstances.N += item.addN;
                $scope.addSubstances.S += item.addS;
                $scope.addSubstances.P += item.addP;
                $scope.addSubstances.K += item.addK;
            });
            console.log($scope.addSubstances);
        }

        $scope.saveCRP = function () {
            var saveCostPlan = [];
            $scope.newCRPLoader = true;
            console.log("ulozeni osevniho planu *************************************************");
            angular.forEach($scope.cropRotationItem, function (item) {
                console.log(item);
                costPlan = {
                    StockItemId: Number(item.StockItemId),
                    WorkId:  Number(item.WorkId),
                    MachineryId:  Number(item.MachineryId),
                    Status: false,
                    AnticipatedCosts:  Number(item.totalCost),
                    ActualCost: 0,
                    Dosage:  Number(item.dosage),
                    Quantiy:  Number(item.quantityMaterial),
                    N:  Number(item.addN),
                    S:  Number(item.addS),
                    P:  Number(item.addP),
                    K:  Number(item.addK),
                    CrpId: 0,
                    DateCreateTick: new Date(item.date).getTime(),
                    DateCreateString: item.date,
                    FuelId: Number(item.fuelId)
                }
                console.log("date == " + item.date);
                console.log("number == " + new Date(item.date).getTime());

                var json = JSON.stringify(item.date);
                console.log("json date == " + json);
                console.log("json number == " + new Date(json).getTime());
                var dateStr = JSON.parse(json);
                console.log(dateStr)


                //console.log("ulozi");
                //console.log(costPlan);
                //item.saveItem.DateCreateTick = new Date(item.date).getTime();
                saveCostPlan.push(costPlan);
                //console.log("push");
                //console.log(saveCostPlan);
            });
            console.log("ulozeni osevniho planu **************************************************");
            
            //console.log("ulozeni osevniho planu");
            //console.log($scope.CRplan);
            console.log("*");
            console.log("*");
            console.log("*");
            console.log("Osevni plan pro ulozeni");
            console.log($scope.CRplan);
            console.log("polozky osevniho planu");
            console.log(saveCostPlan);


            
            crpService.create($scope.CRplan, saveCostPlan,
                function (data)
                {
                    console.log(data);
                    $scope.newCRPLoader = false;
                    $scope.newCRPOk = true;
                    $timeout(function () {
                        $location.path('/app/cropRotationPlan');
                        $scope.newCRPOk = false;
                    }, 3000);
                },
                function (err)
                {
                    console.log(err);
                });
        }
        //---------------------------------------------------------------------
        
    });