﻿'use strict'

dpApp.controller('pickModalController',
    function ($scope, $timeout, $modalInstance, $location, stockItemService, HarvestedCropService, vendorService, $modal) {
        $scope.Modal = true;
        $scope.Complete = false;
        $scope.Loader = false;
        $scope.Validator = false;
        $scope.Error = false;
        $scope.allStockItems = [];
        $scope.pickPrice = 0;

        $scope.cancel = function () {
            $modalInstance.close();
        }

        $scope.changeItemCategory = function (categoryId)
        {
            console.log("Select sategory", categoryId);
            $scope.allStockItems = [];
            $scope.stockItem = null;
            switch (categoryId) {
                case '6':
                    console.log("load harvested");
                    HarvestedCropService.getAll(
                        function (data) {
                            //$scope.allStockItems = data.plain();
                            //console.log($scope.allStockItems);
                            angular.forEach(data.plain(), function (harvestedItem) {
                                console.log(harvestedItem);
                                var obj = {
                                    id: harvestedItem.id,
                                    name: harvestedItem.crop.name,
                                    quantity: harvestedItem.quantity,
                                    measureName: 'Kg',
                                    price: (harvestedItem.quantity * harvestedItem.unitCost),
                                    priceUnit: harvestedItem.unitCost
                                };
                                $scope.allStockItems.push(obj);
                            });
                            console.log("finish load");
                            console.log($scope.allStockItems);

                            /*
                             * <p>Název: <strong>{{stockItem.name}}</strong></p>
                    <p>Množství na skladě: <strong>{{stockItem.quantity}}</strong> {{stockItem.measureName}}</p>
                    <p>Hodnota: <strong>{{stockItem.price}}</strong> Kč</p>
                    <p>Hodnota jednotky: <strong>{{stockItem.priceUnit}}</strong></p>
                             * 
                             */
                        }, function (err) {
                            console.log(err);
                        });
                    break;
                default:
                    stockItemService.getAllCategory(categoryId,
                        function (data) {
                            $scope.allStockItems = data.plain();
                            console.log($scope.allStockItems);
                        },
                        function (err) {
                            console.log("Error load all categories in pick stok item");
                            console.log(err);
                        });
                    break;
            };           
        }

        $scope.changeStockItem = function () {
            console.log("selected stock item");
            console.log($scope.stockItem);
        };

        $scope.chnagePickQuantity = function () {
            $scope.Validator = false;
            if (($scope.pickQuantity == "") || ($scope.pickQuantity == undefined) || ($scope.pickQuantity >= stockItem.quantity)) {
                $scope.Modal = true;
                $scope.Loader = false;
                $scope.Validator = true;
            } else {
                $scope.pickPrice = ($scope.pickQuantity * $scope.stockItem.priceUnit);
            }
        }

        $scope.showNewVendorModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/newVendorModal.html',
                controller: 'newVendorModalController',
                size: 1,
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });
            modalInstance.result.then(function () {
                $scope.loaadModalVendor();
            });
        }

        $scope.loaadModalVendor = function () {
            vendorService.getAll(
                function (data) {
                    console.log("dodavatele");
                    console.log(data.plain());
                    $scope.vendorSelect = data.plain();
                },
                function (err) {
                });
        }
        $scope.loaadModalVendor();


        $scope.save = function (stockItem) {
            $scope.Modal = false;
            $scope.Loader = true;
            $scope.Validator = false;
            $scope.Error = false;
            console.log(stockItem);
            console.log($scope.pickQuantity);
            if (($scope.pickQuantity == "") || ($scope.pickQuantity == undefined) || ($scope.pickQuantity >= stockItem.quantity)) {
                $scope.Modal = true;
                $scope.Loader = false;
                $scope.Validator = true;
            }else{
                $scope.Validator = false;
                switch ($scope.selectedCategory) {
                    case '6':
                        //harvestead
                        
                        HarvestedCropService.getById(stockItem.id,
                            function (data) {
                                var currentStockItem = data.plain();
                                console.log("current stock item");

                                console.log(currentStockItem);

                                var businessPrice = Math.round(Number($scope.pickQuantity) * Number(currentStockItem.unitCost)).toFixed(2);
                                var vendorId = 1;
                                if (($scope.pickVendor == "") || ($scope.pickVendor == undefined)) {
                                    vendorId = 1;
                                } else {
                                    vendorId = $scope.pickVendor.id;
                                }
                                var objectBusinessRecordHarvested = {
                                    name: currentStockItem.crop.name,
                                    description: $scope.businessRecordDescription,
                                    price: businessPrice,
                                    quantity: $scope.pickQuantity,
                                    categoryId: 6,
                                    MeasureId: 0,
                                    HarvestedItemId: currentStockItem.id,
                                    VendorId: vendorId,
                                    Income: false,
                                    measureId: 0
                                }
                                console.log(currentStockItem);
                                currentStockItem.quantity = Math.round(Number(currentStockItem.quantity) - Number($scope.pickQuantity)).toFixed(2);
                                currentStockItem.cost = currentStockItem.cost - businessPrice;

                                
                                HarvestedCropService.pickHarvestedItem(currentStockItem, objectBusinessRecordHarvested,
                                    function (data) {
                                        $scope.Loader = false;
                                        $scope.Complete = true;

                                        $timeout(function () {
                                            $modalInstance.close();
                                        }, 1500);
                                    },
                                    function (err) {
                                        console.log("save pick error");
                                        console.log(err);
                                        $scope.Modal = true;
                                        $scope.Loader = false;
                                        $scope.Error = true;
                                    });
                            },
                            function (err) {
                                console.log("Pick stock item error");
                                console.log(err);
                                $scope.Modal = true;
                                $scope.Loader = false;
                                $scope.Error = true;
                            });


                        break;
                    default:
                        //stock items
                        stockItemService.getById(stockItem.id,
                            function (data) {
                                var currentStockItem = data.plain();
                                console.log("current stock item");
                                
                                console.log(currentStockItem);
                                
                                var businessPrice = Math.round(Number($scope.pickQuantity) * Number(currentStockItem.priceUnit)).toFixed(2);
                                var vendorId = 1;
                                if (($scope.pickVendor == "") || ($scope.pickVendor == undefined)) {
                                    vendorId = 1;
                                } else {
                                    vendorId = $scope.pickVendor.id;
                                }
                                
                                var objectBusinessRecord = {
                                    name: currentStockItem.name,
                                    description: $scope.businessRecordDescription,
                                    price: businessPrice,//
                                    quantity: $scope.pickQuantity,//
                                    categoryId: $scope.selectedCategory,
                                    MeasureId: currentStockItem.measureId,
                                    StockItemId: currentStockItem.id,
                                    VendorId: vendorId, // vlastni spotreba nebo zvolenej
                                    Income: false
                                };
                                currentStockItem.quantity = Math.round(Number(currentStockItem.quantity) - Number($scope.pickQuantity)).toFixed(2);
                                currentStockItem.price = currentStockItem.price - businessPrice;
                                
                                stockItemService.pickStockItem(currentStockItem, objectBusinessRecord,
                                    function (data) {
                                        $scope.Loader = false;
                                        $scope.Complete = true;

                                        $timeout(function () {
                                            $modalInstance.close();
                                        }, 1500);
                                    },
                                    function (err) {
                                        console.log("save pick error");
                                        console.log(err);
                                        $scope.Modal = true;
                                        $scope.Loader = false;
                                        $scope.Error = true;
                                    });
                            },
                            function (err) {
                                console.log("Pick stock item error");
                                console.log(err);
                                $scope.Modal = true;
                                $scope.Loader = false;
                                $scope.Error = true;
                            });
                        
                        break;
                }
            };
        }
    });
