﻿'use strict'

dpApp.controller('stockController',
    function ($scope, stockItemService, $modal, HarvestedCropService) {
        $scope.model = { text: "dostupne" };

        $scope.loadStock = function loadStock(categoryId) {
            $scope.stockLoader = false;
            $scope.stockTable = false;
            console.log("click na load " + categoryId);
            stockItemService.getAllCategory(categoryId,
                function (data) {
                    console.log("nacteno kategorie " + categoryId);
                    console.log(data.plain());
                    $scope.stockLoader = true;
                    if (data.plain().length) { $scope.stockTable = true; } else { $scope.stockTable = false; }
                    switch(categoryId) {
                        case 1:
                            $scope.stockSeedsTable = data.plain();
                            break;
                        case 2:
                            $scope.stockManureTable = data.plain();
                            break;
                        case 3:
                            $scope.stockPlanProtectionTable = data.plain();
                            break;
                        case 4:
                            $scope.stockFuelTable = data.plain();
                            break;
                        case 5:
                            $scope.stockOtherTable = data.plain();
                            break;
                    }
                },
                function (err) {
                    console.log("chyba");
                    console.log(err);
                });
        }

        $scope.loadHarvested = function () {
            console.log("load harvestead");
            $scope.stockLoader = false;
            $scope.stockTable = false;
            HarvestedCropService.getAll(
                function (data) {
                    console.log(data.plain());
                    $scope.stockLoader = true;
                    if (data.plain().length) { $scope.stockTable = true; } else { $scope.stockTable = false; }
                    $scope.stockHarvestedTable = data.plain();
                }, function (err) {
                    console.log(err);
                });
        }

        $scope.loadStockStatus = function(){
        stockItemService.getStockStatus(
            function (data) {
                console.log("stockStatus");
                console.log(data.plain());
                $scope.totalStockQuantity = 0;
                $scope.totalStockMerit = 0;
                angular.forEach(data.plain(),
                    function (data)
                    {
                        $scope.totalStockQuantity += Number(data.quantity);
                        $scope.totalStockMerit += Number(data.merit);
                        switch (data.categoryId)
                        {
                            case 1:
                                $scope.cat1quantity = data.quantity;
                                $scope.cat1merit = data.merit;
                                break;
                            case 2:
                                $scope.cat2quantity = data.quantity;
                                $scope.cat2merit = data.merit;
                                break;
                            case 3:
                                $scope.cat3quantity = data.quantity;
                                $scope.cat3merit = data.merit;
                                break;
                            case 4:
                                $scope.cat4quantity = data.quantity;
                                $scope.cat4merit = data.merit;
                                break;
                        }
                    });
            }, function (err) {
                console.log(err);
            });
        }
        $scope.loadStockStatus();

        // actions
        $scope.showItemModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/stockItemModal.html',
                controller: 'stockItemModalController',
                size: 'lg',
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });
            modalInstance.result.then(function () {
                $scope.loadStock(1);
                $scope.loadStockStatus();
            });
        }

        $scope.showAddItemModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/addStokItemModal.html',
                controller: 'addStockItemModalController',
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });

            modalInstance.result.then(function () {
                $scope.loadStock(1);
                $scope.loadStockStatus();
            });
        }

        $scope.showPickModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/pickModal.html',
                controller: 'pickModalController',
                size: 'lg',
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });

            modalInstance.result.then(function () {
                $scope.loadStock(1);
                $scope.loadStockStatus();
            });
        }

        $scope.showToDoModal = function () {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/todoModal.html',
                controller: 'todoModalController',
                size: 'sm',
                resolve: {
                    data: function () {
                        return [];
                    }
                }
            });
        }
    }
);

