﻿//stock service
dpApp.service('stockItemService', ['Restangular',
    function (Restangular) {
        this.create = function (data, objectBusinessRecord, success, fail) {
            Restangular.all('stock/newStockItem').post(data).then(
                function (idStockItem) {
                    console.log("id stock item " + idStockItem);
                    objectBusinessRecord.StockItemId = idStockItem;
                    Restangular.all('businessRecord').post(objectBusinessRecord).then(success, fail);
                }, fail);
        };

        this.addToStock = function (data, objectBusinessRecord, success, fail) {
            Restangular.all('stock').post(data).then(
                function () {
                    Restangular.all('businessRecord').post(objectBusinessRecord).then(success, fail);
                }, fail);
        };

        this.getAllCategory = function (categoryId, success, fail) {
            Restangular.all('stock').one("category", categoryId).get(categoryId).then(success, fail);
        };

        this.getCategoryByRelation = function (categoryId, relationId, success, fail) {
            Restangular.all('stock').one("category", categoryId).one("relation", relationId).get().then(success, fail);
        };

        this.getStockStatus = function (success, fail) {
            Restangular.all('stock').one("status").get().then(success, fail);
        };

        this.getById = function (stockItemId, success, fail) {
            Restangular.all('stock').get(stockItemId).then(success, fail);
        }

        this.pickStockItem = function (stockItem, businessRecordModel, success, fail) {
            Restangular.all('stock').post(stockItem).then(
                                function () {
                                    Restangular.all('businessRecord').post(businessRecordModel).then(success, fail);
                                }, fail);
        };
    }
]);