﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("Crop")]
    public class CropController : BaseController<Crop, CropViewModel>
    {
        public CropController() : base(new CropService())
        {
        }
        protected override Crop ModelToData(CropViewModel model)
        {
            return new Crop
            {
                CompanyId = IdentityHelper.CurrentUser.CompanyId,
                Id = model.Id,
                Name = model.Name,
                Description = model.Description,
                N = model.N,
                S = model.S,
                P = model.P,
                K = model.K
            };
        }

        protected override CropViewModel DataToModel(Crop data)
        {
            return new CropViewModel
            {
                CompanyId = data.CompanyId,
                CreatedAt = data.CreatedAt,
                Id = data.Id,
                Name = data.Name,
                Description = data.Description,
                N = data.N,
                S = data.S,
                P = data.P,
                K = data.K
            };
        }
    }
}
