﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("CropItem")]
    public class CropItemController : BaseController<CropItem, CropItemViewModel>
    {
        public CropItemController()
            : base(new CropItemService())
        {

        }
        protected override CropItem ModelToData(CropItemViewModel model)
        {

            DateTimeOffset modelHarvestedDate = model.DateHarvested;
            if (model.DateHarvestedString != null)
            {
                modelHarvestedDate = DateTimeOffset.Parse(model.DateHarvestedString);
            }
            return new CropItem
            {
                CreatedAt = model.CreatedAt,
                CropId = model.CropId,
                CropRotationPlanId = model.CropRotationPlanId,
                DateHarvested = modelHarvestedDate,
                Id = model.Id,
                Quantity = model.Quantity,
                CompanyId = IdentityHelper.CurrentUser.CompanyId
            };
        }

        protected override CropItemViewModel DataToModel(CropItem data)
        {
            return new CropItemViewModel
            {
                CreatedAt = data.CreatedAt,
                CropId = data.CropId,
                CropRotationPlanId = data.CropRotationPlanId,
                DateHarvested = data.DateHarvested,
                Id = data.Id,
                Quantity = data.Quantity
            };
        }
    }
}