﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("harvestedCrop")]
    public class HarvestedCropController : BaseController<HarvestedCrop, HarvestedCropViewModel>
    {
        public HarvestedCropService Service { get; set; }

        public HarvestedCropController(HarvestedCropService service)
            : base(service)
        {
            Service = service;
        }

        [Route("getByCrop/{CropId}"), HttpGet]
        public async Task<IEnumerable<HarvestedCrop>> GetByCrop(long CropId)
        {
            return await Service.GetByCrop(CropId);
        }
        protected override HarvestedCrop ModelToData(HarvestedCropViewModel model)
        {
            return new HarvestedCrop 
            {
                Id = model.Id,
                CompanyId = IdentityHelper.CurrentUser.CompanyId,
                CreatedAt = model.CreatedAt,
                DateChange = model.DateChange,
                Quantity = model.Quantity,
                Cost = model.Cost,
                CropId = model.CropId
            };
        }

        protected override HarvestedCropViewModel DataToModel(HarvestedCrop data)
        {
            float _unitCost = 0;
            if (data.Quantity > 0)
            {
                _unitCost = data.Cost / data.Quantity;
            }

            return new HarvestedCropViewModel
            {
                Id = data.Id,
                CompanyId = data.CompanyId,
                CreatedAt = data.CreatedAt,
                DateChange = data.DateChange,
                Quantity = data.Quantity,
                Cost = data.Cost,
                unitCost = _unitCost,
                crop = new CropController().Get(data.CropId).Result,
                CropId = data.CropId
            };
        }
    }
}