﻿using bussines.Services;
using Data;
using Data.Models;
using Data.Repositories;
using WebAppDp.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Web.Helpers;
using System.Web.Http;
using Data.Interfaces;
using System.Threading;
using WebAppDp.Helpers;
using Data.Enums;
using System.Threading.Tasks;
using LightInject;
using business;

namespace WebAppDp.Controllers
{
    [RoutePrefix("Login")]
    public class LoginController : ApiController
    {

        // todo: move services use into special one

        [Inject]
        public IService<Address> AddressService { get; set; }

        [Inject]
        public IService<Contact> ContactService { get; set; }

        [Inject]
        public IService<Company> CompanyService { get; set; }

        [Inject]
        public IService<User> UserService { get; set; }

        [Inject]
        public IService<Vendor> VendorService { get; set; }

        [Route("UserInfo/{id:int}"), HttpGet]
        public async Task<InfoUserVM> GetUserInfo(string id) 
        {
            return await Task.Run(() =>
            {

                User aktUser = UserService.GetById(Convert.ToInt64(IdentityHelper.CurrentUser.Id)).Result;

                InfoUserVM dataUser = new InfoUserVM
                {
                    Name = aktUser.Name,
                    LastName = aktUser.LastName,
                    AddressId = aktUser.AddressId,
                    CompanyId = aktUser.CompanyId
                };

                return Task.FromResult(dataUser);
            });
        }

        [Route("SaveRegistration"), HttpPost]
        public object SaveRegistration(RegistrationVM data)
        {

            var Company = data.Company;
            var User = data.User;

            User.Password = Utils.GetHash(User.Password);
            User.Role = UserRole.Admin; //TODO change

            long idAddress = AddressService.Put(data.Address).Result;
            long idContact = ContactService.Put(data.Contact).Result;


            Company.AdderessId = idAddress;
            Company.ContactId = idContact;
            long idCompany = CompanyService.Put(Company).Result;
            Company.Id = idCompany;

            User.AddressId = idAddress;
            User.ContactId = idContact;
            User.CompanyId = idCompany;
            long idUser = UserService.Put(User).Result;

            Vendor MainVendor = new Vendor
            {
                AddressId = idAddress,
                CompanyId = idCompany,
                ContactId = idContact,
                Dic = Company.Dic,
                Ico = Company.Ico,
                Name = "Vlastní výroba",
                Production = true
            };

            VendorService.Put(MainVendor);


            return Company;
        }

    }
}