﻿using business;
using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("Machinery")]
    public class MachineryController : BaseController<Machinery, MachineryViewModel>
    {
        public MachineryController() : base(new MachineryService())
        {
        }

        protected override Machinery ModelToData(MachineryViewModel model)
        {
            return new Machinery
            {
                Id = model.Id,
                CompanyId = IdentityHelper.CurrentUser.CompanyId,
                CreatedAt = model.CreatedAt,
                Name = model.Name,
                Description = model.Description,
                AvarangeConsumption = model.AvarangeConsumption,
                Hours = model.Hours,
                LicensePlate = model.LicensePlate
            };
        }

        protected override MachineryViewModel DataToModel(Machinery data)
        {
            return new MachineryViewModel
            {
                Id = data.Id,
                CompanyId = data.CompanyId,
                CreatedAt = data.CreatedAt,
                Name = data.Name,
                Description = data.Description,
                AvarangeConsumption = data.AvarangeConsumption,
                Hours = data.Hours,
                LicensePlate = data.LicensePlate

            };
        }
    }
}