﻿using business;
using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("partsoilblock")]
    public class PartSoilBlockController : BaseController<PartSoilBlock, PartSoilBlockViewModel>
    {
        public PartSoilBlockService Service { get; set; }

        public PartSoilBlockController(PartSoilBlockService service)
            : base(service)
        {
            Service = service;
        }

        [Route("GetPartBySoilBlockId/{SoilBlockId}/year/{year}"), HttpGet]
        public async Task<IEnumerable<PartSoilBlockViewModel>> GetPartBySoilBlockId(long SoilBlockId, long year) 
        {
            return await Task.FromResult(DataToModels((Service as PartSoilBlockService).GetBySoilBlock(SoilBlockId, year).Result));
        }

        protected override PartSoilBlock ModelToData(PartSoilBlockViewModel model)
        {
            return PartSoilBlockHelper.ModelToData(model);
        }

        protected override PartSoilBlockViewModel DataToModel(PartSoilBlock data)
        {
            return PartSoilBlockHelper.DataToModel(data);
        }
    }
}
