﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("machineConsumption")]
    public class WcatToMachineController : BaseController<WcatToMachine, WcatToMachineViewModel>
    {

        WcatToMachineService Service { get; set; }

        public WcatToMachineController(WcatToMachineService service)
            : base(service)
        {
            Service = service;
        }

        [Route("work/{workId}/machinery/{machineryId}"), HttpGet]
        public async Task<float> GetConsumption(long workId, long machineryId)
        {
            return await Service.GetConsumption(workId, machineryId);
        }
        protected override WcatToMachine ModelToData(WcatToMachineViewModel model)
        {
            return new WcatToMachine
            {
                AverageConsumption = model.AverageConsumption,
                CreatedAt = model.CreatedAt,
                Id = model.Id,
                MachineId = model.MachineId,
                WorkId = model.WorkId
            };
        }

        protected override WcatToMachineViewModel DataToModel(WcatToMachine data)
        {
            return new WcatToMachineViewModel
            {
                AverageConsumption = data.AverageConsumption,
                CreatedAt = data.CreatedAt,
                Id = data.Id,
                MachineId = data.MachineId,
                WorkId = data.WorkId
            };
        }
    }
}