﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using WebAppDp.Helpers;
using WebAppDp.ViewModels;

namespace WebAppDp.Controllers
{
    [Authorize]
    [RoutePrefix("workCategory")]
    public class WorkCategoryController : BaseController<WorkCategory, WorkCategoryViewModel>
    {
        public WorkCategoryController() : base(new WorkCategoryService())
        {
        }
        protected override WorkCategory ModelToData(WorkCategoryViewModel model)
        {
            return new WorkCategory
            {
                Id = model.Id,
                CompanyId = IdentityHelper.CurrentUser.CompanyId,
                Name = model.Name,
                Description = model.Description,
                Price = model.Price,
                AverageConsumption = model.AverageConsumption
            };
        }

        protected override WorkCategoryViewModel DataToModel(WorkCategory data)
        {
            return new WorkCategoryViewModel
            {
                Id = data.Id,
                CompanyId = data.CompanyId,
                CreatedAt = data.CreatedAt,
                Name = data.Name,
                Description = data.Description,
                Price = data.Price,
                AverageConsumption = data.AverageConsumption
            };
        }
    }
}