﻿using bussines.Managers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace WebAppDp.Handlers
{
    /// <summary>
    /// Summary description for Export
    /// </summary>
    public class Export : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            int year = DateTimeOffset.UtcNow.Year;

            string fiscalYear = context.Request.QueryString["year"];
            if (!string.IsNullOrEmpty(fiscalYear)){
                year = int.Parse(fiscalYear);
            }

            context.Response.StatusCode = 200;
            context.Response.AddHeader("content-disposition", "attachment; filename=export.xlsx");
            context.Response.ContentType = "application/octet-stream";

            using (var xlStream = new ExportManager().ExportCropRotationExcel(year))
            {
                xlStream.CopyTo(context.Response.OutputStream);
            }

        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}