﻿using bussines.Services;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using WebAppDp.Controllers;
using WebAppDp.ViewModels;

namespace WebAppDp.Helpers
{
    public static class PartSoilBlockHelper
    {
        public static PartSoilBlock ModelToData(PartSoilBlockViewModel model)
        {
            return new PartSoilBlock
            {
                Area = model.Area,
                Description = model.Description,
                Id = model.Id,
                MarketingYear = model.MarketingYear,
                SoilBlockId = model.SoilBlockId
            };
        }

        public static PartSoilBlockViewModel DataToModel(PartSoilBlock data)
        {
            var soilBlockService = new SoilBlockService();
            var crpService = new CropRotationPlanService();
            var cropService = new CropService();
            var cropRotationPlan = crpService.GetCrpByPartId(data.Id).Result;
            var crp = false;
            var cropName = "Nenalezeno";
            if (cropRotationPlan != null) {
                cropName = cropService.GetById(cropRotationPlan.CropId).Result.Name;
                crp = true;
            }

            return new PartSoilBlockViewModel
            {
                Area = data.Area,
                Description = data.Description,
                Id = data.Id,
                MarketingYear = data.MarketingYear,
                SoilBlockId = data.SoilBlockId,
                soilBlock = soilBlockService.GetById(data.SoilBlockId).Result,
                CropName = cropName,
                ExistCrp = crp
            };
        }

        public static IEnumerable<PartSoilBlockViewModel> DataToModels(IEnumerable<PartSoilBlock> data)
        {
            return data.Select(p => DataToModel(p));
        }
    }
}