﻿var dpApp = angular.module('dpApp', [
    'ngRoute',
    'ngSanitize',
    'LocalStorageModule',
    'ngCookies',
    'ui.bootstrap',
    'ui.bootstrap.tpls',
    'restangular',
    //'ngSlider',
    'smart-table',
    'ui.sortable',
    'angular-svg-round-progress',
    'angularAwesomeSlider'
]);

// Constants
dpApp.constant('ngAuthSettings', {
    baseUrl: 'http://zemedelec.azurewebsites.net',//false ? 'http://zemedelec.azurewebsites.net' : 'http://localhost:4407',
    //baseUrl: 'http://localhost:4407',
    clientId: 'ngAuthApp'
});

// Interceptors
dpApp.config(function ($httpProvider) {
    $httpProvider.interceptors.push('authInterceptor');
});


dpApp.run(['$rootScope', '$location', 'ngAuthSettings', 'authService',
    function ($rootScope, $location, ngAuthSettings, authService) {
        authService.fillAuthData();

        // Global functions
        $rootScope.isActive = function (route) {
            console.log("is activeMethod", route);
            return $location.path() === route || $location.path().indexOf(route) == 0;
        }

        // Check permissions and make changes when the route has been changed
        $rootScope.$on('$locationChangeStart', function (event, next, current) {
            var isInApp = next.indexOf(ngAuthSettings.baseUrl + '/#/app') == 0;
            $rootScope.isInApp = isInApp;

            if (!authService.authentication.isAuth && isInApp) {
                $location.path('/unauthorized');
                event.preventDefault();
            }
        });
}])

