﻿'use strict'

dpApp.controller('crpController',
    function ($scope, $rootScope, crpService, $modal, costPlanService, stockItemService, workCategoryService) {
        console.log("crop rotation plan controller");
        $scope.detailCRP = null;
        $scope.showDetailCRPContent = false;

        $scope.crpLoader = false;
        $scope.crpTable = [];
        $scope.loadCropRotationPlanInfo = function () {
            $scope.crpLoader = false;
            $scope.crpTable = [];
            crpService.getCrpInfo($rootScope.globalMarketingYear,
                    function (data) {
                        if (data.length > 0) {
                            angular.forEach(data.plain(), function (crp) {
                                var allItems = 0;
                                var finishItems = 0;
                                costPlanService.getAllCrp(crp.id,
                                    function (item) {
                                        angular.forEach(item.plain(),
                                            function (costItem) {
                                                allItems += 1;
                                                if (costItem.status) { finishItems += 1; };
                                            });
                                        crp.allItems = allItems;
                                        crp.endItems = finishItems;
                                        $scope.crpTable.push(crp);

                                    },
                                    function (err) { });
                            });

                            //$scope.crpTable = data.plain();
                            console.log("load crp");
                            console.log(data.plain());
                        }
                        $scope.crpLoader = true;
                    }, function (err) {
                        console.log("error load info about crop " + err);
                        console.log(err);
                        $scope.crpLoader = true;
                    });
        }

        $scope.loadCropRotationPlanInfo();

        $rootScope.$on("updateDataChangeMarketingYear", function (e) {
            console.log("change main marketing year for crop rotation plan");
            $scope.loadCropRotationPlanInfo();
        });

        $scope.hideDetailCRP = function ()
        {
            $scope.showDetailCRPContent = false;
            $scope.crpItems = [];
        }

        $scope.crpItems = [];
        
        $scope.showUpdateCrpItem = function (item)
        {
        //update items
            item.updateCrpItem = true;
            stockItemService.getCategoryByRelation(item.base.stockItem.categoryId, $scope.detailCRP.crop.id,
                function (data) {
                    item.selectMaterials = data.plain();
                    console.log(data.plain());
                },
                function (err) {
                    console.log(err);
                });
        }

        $scope.hideUpdateCrpItem = function (item) {
            item.updateCrpItem = false;
        }

        $scope.showDetailCRP = function (crpId)
        {
            $scope.crpDetailLoader = false;
            crpService.getById(crpId,
                function (data) {
                    console.log("load detail crp ok");
                    $scope.detailCRP = data.plain();

                    $scope.showDetailCRPContent = true;
                    $scope.crpItems = [];

                    costPlanService.getAllCrp(crpId,
                        function (data) {
                            console.log(data.plain());
                            angular.forEach(data.plain(),
                                function (item) {
                                    var avgCon = 0;
                                    if ((item.machineryId > 0) && (item.workId > 0)) {
                                        console.log("machine id: " + item.machineryId + " work id: " + item.workId);
                                        workCategoryService.getConsumption(item.workId, item.machineryId,
                                            function (data) {
                                                console.log("spotreba");
                                                console.log(data);
                                                avgCon = data;
                                                var cropRotationPlanItems = {
                                                    base: item,
                                                    openStatus: false,
                                                    updateCrpItem: false,
                                                    materialQuantity: (item.dosage * $scope.detailCRP.partSoilBlock.area),
                                                    materialCost: ((item.stockItem.price / item.stockItem.quantity) * (item.dosage * $scope.detailCRP.partSoilBlock.area)),
                                                    workCost: (item.workCategory.price * $scope.detailCRP.partSoilBlock.area),
                                                    totalConsumption: (avgCon * $scope.detailCRP.partSoilBlock.area),
                                                    selectMaterials: null,
                                                    avgConsumption: avgCon
                                                }

                                                $scope.crpItems.push(cropRotationPlanItems);
                                                $scope.crpDetailLoader = true;
                                            }, function (err) {
                                                console.log(err);
                                            });
                                    }
                                });
                            //vse ok
                        },
                        function (err) {
                            console.log(err);
                        });
                },
                function (err) {
                });
        }


        $scope.showConfirmCrpModal = function (data, soilBlck) {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/confirmCrpModal.html',
                controller: 'confirmCrpModalController',
                size: 'lg',
                resolve: {
                    confirmItem: function () {
                        return data;
                    },
                    soilBlockInfo: function () {
                        return soilBlck;
                    }
                }
            });

            modalInstance.result.then(function () {
                $scope.showDetailCRP($scope.detailCRP.id);
            });
        }

        $scope.showHarvestedModal = function (detailCRP) {
            console.log("sklizen pro");
            console.log(detailCRP);
            console.log("polozky plany");
            console.log($scope.crpItems);
            var canHarvestead = true;
            angular.forEach($scope.crpItems, function (crpItem) {
                if (!crpItem.base.status) {
                    canHarvestead = false;
                }
            });
            console.log("canHarvestead ", canHarvestead);

            if (canHarvestead) {
                var modalInstance = $modal.open({
                    templateUrl: '/Scripts/_app/views/modals/harvestedModal.html',
                    controller: 'harvestedCropModalController',
                    //size: 'sm',
                    resolve: {
                        detailCRP: function () {
                            return detailCRP;
                        }
                    }
                });

                modalInstance.result.then(function () {
                });
            } else {
                var modalInstance = $modal.open({
                    templateUrl: '/Scripts/_app/views/modals/harvestedVarningModal.html',
                    controller: 'harvestedVarningModalController',
                    size: 'sm',
                    resolve: {
                        data: function () {
                            return;
                        }
                    }
                });

                modalInstance.result.then(function () {
                });
            };
        }

        $scope.showAddCostItemModal = function (categoryId,cropId,area,cropRotationPlanId) {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/addCostItemModal.html',
                controller: 'addCostItemModalController',
                size: 'lg',
                resolve: {
                    categoryId: function () {
                        return categoryId;
                    },
                    cropId: function () {
                        return cropId;
                    },
                    partSoilBlockarea: function () {
                        return area;
                    },
                    cropRotationPlanId: function () {
                        return cropRotationPlanId;
                    }
                }
            });

            modalInstance.result.then(function () {
                console.log("konec pridani znovunacteni " + cropRotationPlanId);
                $scope.showDetailCRP(Number(cropRotationPlanId));
            });
        }

        $scope.showDeleteCrpModal = function (crpItem) {
            var modalInstance = $modal.open({
                templateUrl: '/Scripts/_app/views/modals/addCostItemModal.html',
                controller: 'removeCrpModalController',
                size: 'lg',
                resolve: {
                    crpItem: function () {
                        return crpItem;
                    }
                }
            });

            modalInstance.result.then(function () {
                console.log("konec pridani znovunacteni " + cropRotationPlanId);
                $scope.showDetailCRP(Number(cropRotationPlanId));
            });
        };
                
    });