﻿'use strict'

dpApp.controller('invoiceController',
    function ($scope, $location, invoiceService, vendorService, businessRecordService, confirmModalFactory) {
        $scope.businessRecordFrom = new Date(new Date().setMonth(new Date().getMonth() - 1));
        $scope.businessRecordTo = new Date();
        $scope.loadBusinessRecords = false;
        $scope.VendorBankValidator = false;

        $scope.invoiceData = {
            invoiceNumber: 0,
            payType: 0,
            invoiceType: 0,
            invoiceItemsCSV: "",
            payDate: null,

            customer: {
                id: "",
                name: "",
                ic: "",
                dic: "",
                street: "",
                city: "",
                zipCode: "",
                email: "",
                tel: ""
            },

            vendor: {
                id:"",
                name: "",
                ic: "",
                dic: "",
                street: "",
                city: "",
                zipCode: "",
                email: "",
                tel: ""
            },

            bankAccount: {
                numberPrefix: "",
                number: "",
                bankCode: "",
                variableSym: "",
                constSym: "",
                specSym: "",
                SWIFT: "",
                IBAN: "",
            },

            items: []
        }

        $scope.dataItem = {
            desc: "",
            count: "",
            price: "",
        }

        $scope.InvoiceNumberValidator = true;
        $scope.currentCustomerValidator = false;
        $scope.currentCustomerBankValidator = false;
        $scope.symbolValidator = false;
        $scope.symbolValidatorMsg = []; 
        $scope.customValidator = false;
        $scope.customValidatorMsg = [];

        function JSONToCSVConvertor(JSONData, ReportName, ShowLabel) {

            //If JSONData is not an object then JSON.parse will parse the JSON string in an Object
            var arrData = typeof JSONData != 'object' ? JSON.parse(JSONData) : JSONData;

            var CSV = '';
            if (ShowLabel) {
                var row = "";
                //This loop will extract the label from 1st index of on array
                for (var index in arrData[0]) {
                    //Now convert each value to string and comma-seprated
                    row += index + ',';
                }
                row = row.slice(0, -1);

                //append Label row with line break
                CSV += row + '\r\n';
            }
            //1st loop is to extract each row
            for (var i = 0; i < arrData.length; i++) {
                var row = "";
                //2nd loop will extract each column and convert it in string comma-seprated
                for (var index in arrData[i]) {
                    row += '"' + arrData[i][index] + '",';
                }
                row.slice(0, row.length - 1);
                //add a line break after each row
                CSV += row + '\r\n';
            }
            if (CSV == '') {
                alert('No data available');
                return;
            }
            return CSV;
        }

        $scope.loadBusinessRecordsMenu = function () {
            $scope.loadBusinessRecords = true;
            var type = true;
            if ($scope.invoiceData.invoiceType == 0) {
                type = false;
            };
            console.log($scope.invoiceData.invoiceType, type);
            $scope.loadBusinessRecordType(type);
        };

        $scope.addBusinessRecord = function () {
            console.log($scope.selectedBusinessRecord);
            var description = $scope.selectedBusinessRecord.description;
            if (description != null) {
                description = " ( " + description.trim() + " ) ";
            } else {
                description = " - ";
            }
            $scope.dataItem.desc = $scope.selectedBusinessRecord.name.trim() + description + ' Množství v jednotkách: ' + $scope.selectedBusinessRecord.measureName;
            $scope.dataItem.count = $scope.selectedBusinessRecord.quantity;
            $scope.dataItem.price = $scope.selectedBusinessRecord.price;
        };

        $scope.loadBusinessRecordType = function (type) {
            var obj = {
                From: document.getElementById("businessRecordFrom").value,
                To: document.getElementById("businessRecordTo").value,
                Type: type
            };
            businessRecordService.getAllByType(obj,
                function (data) {
                    $scope.businessRecordTable = data.plain();
                    angular.forEach($scope.businessRecordTable, function (item) {
                        var date = item.createdAt.split('T');
                        date = date[0].split('-');
                        var type = '- ';
                        if (item.income) {
                            type = '+ ';
                        };
                        item.selectValue = type + ' ' + date[2] + '.' + date[1] + '. ' + date[0] + ' - ' + item.name + ' | ' + item.quantity + ' ' + item.measureName + ' | ' + item.price + ' Kč';
                    });
                },
                function (err) {
                    console.log(err);
                });
        }
        

        // load vendor
        invoiceService.getCompanyInfo(
            function (data) {
                $scope.invoiceData.vendor = data;
            },
            function () { });

        invoiceService.getLastInvoiceNumber(
            function (data) {
                $scope.invoiceData.invoiceNumber = data;
            },
            function () { });

        $scope.checkInvoiceNumber = function () {
            invoiceService.checkInvoiceNumber($scope.invoiceData.invoiceNumber,
            function (data) {
                $scope.InvoiceNumberValidator = data;
            },
            function () { });
        };

        $scope.changePayType = function () {
            $scope.showBankAccountData = false;
            $scope.VendorBankValidator = false;
            $scope.loadBusinessRecords = false;
            if ($scope.invoiceData.payType == 1) {
                if ($scope.invoiceData.invoiceType == 0) {
                    //customer
                    if ($scope.currentCustomer == undefined) {
                        $scope.currentCustomerValidator = true;
                        return;
                    } else {
                        if ($scope.currentCustomer.bankAccountId == 0) {
                            $scope.currentCustomerBankValidator = true;
                            return;
                        } else {
                            $scope.invoiceData.bankAccount.numberPrefix = $scope.currentVendor.bankAccountModel.numberPrefix;
                            $scope.invoiceData.bankAccount.number = $scope.currentVendor.bankAccountModel.number;
                            $scope.invoiceData.bankAccount.bankCode = $scope.currentVendor.bankAccountModel.bankCode;
                            $scope.invoiceData.bankAccount.SWIFT = $scope.currentVendor.bankAccountModel.swift;
                            $scope.invoiceData.bankAccount.IBAN = $scope.currentVendor.bankAccountModel.iban;
                            $scope.showBankAccountData = true;
                        };
                    };
                } else {
                    //vendor
                    if ($scope.currentVendor == undefined) {
                        $scope.currentCustomerValidator = true;
                        return;
                    } else {
                        if ($scope.currentVendor.bankAccountId == 0) {
                            $scope.VendorBankValidator = true;
                            return;
                        } else {
                            $scope.invoiceData.bankAccount.numberPrefix = $scope.currentCustomer.bankAccountModel.numberPrefix;
                            $scope.invoiceData.bankAccount.number = $scope.currentCustomer.bankAccountModel.number;
                            $scope.invoiceData.bankAccount.bankCode = $scope.currentCustomer.bankAccountModel.bankCode;
                            $scope.invoiceData.bankAccount.SWIFT = $scope.currentCustomer.bankAccountModel.swift;
                            $scope.invoiceData.bankAccount.IBAN = $scope.currentCustomer.bankAccountModel.iban;
                            $scope.showBankAccountData = true;
                        };
                    };
                };
            };
        };

        $scope.saveInvoice = function () {
            $scope.symbolValidator = false;
            $scope.symbolValidatorMsg = [];
            $scope.customValidator = false;
            $scope.customValidatorMsg = [];
            //$scope.JSONToCSVConvertor($scope.invoiceData.items, "test", true);
            console.log(JSONToCSVConvertor($scope.invoiceData.items, "test", true));
            $scope.invoiceData.invoiceItemsCSV = JSONToCSVConvertor($scope.invoiceData.items, "test", true);
            $scope.invoiceData.payDate = document.getElementById("payDate").value;
            $scope.invoiceData.customerId = $scope.invoiceData.customer.id;
            $scope.invoiceData.vendorId = $scope.invoiceData.vendor.id;
            var totalCost = 0;
            angular.forEach($scope.invoiceData.items, function (item) {
                totalCost += item.price;
            });
            $scope.invoiceData.totalCost = totalCost;
            $scope.invoiceData.invoiceType = Number($scope.invoiceData.invoiceType);
            $scope.invoiceData.payType = Number($scope.invoiceData.payType);
            console.log($scope.invoiceData);

            if (Number($scope.invoiceData.payType))
            {
                if ($scope.invoiceData.bankAccount.constSym == undefined) {
                    //nevalidni vstup
                    $scope.symbolValidator = true;
                    $scope.symbolValidatorMsg.push("Konstantní symbol není validní. (Pouze číslice)");
                } else {
                    if ($scope.invoiceData.bankAccount.constSym != null) {
                        //nejaky vstup validni
                        var testVariableSym = $scope.invoiceData.bankAccount.constSym + "";
                        if (testVariableSym.length > 4) {
                            //moc dlouhy
                            $scope.symbolValidator = true;
                            $scope.symbolValidatorMsg.push("Konstantní symbol má maximální délku 4.");
                        }
                    }
                }

                if ($scope.invoiceData.bankAccount.variableSym == undefined) {
                    //nevalidni vstup
                    $scope.symbolValidator = true;
                    $scope.symbolValidatorMsg.push("Variabilní symbol není validní. (Pouze číslice)");
                } else {
                    if ($scope.invoiceData.bankAccount.variableSym != null) {
                        //nejaky vstup validni
                        var testVariableSym = $scope.invoiceData.bankAccount.variableSym + "";
                        if (testVariableSym.length > 10) {
                            //moc dlouhy
                            $scope.symbolValidator = true;
                            $scope.symbolValidatorMsg.push("Variabilní symbol má maximální délku 10.");
                        }
                    }
                }

                if ($scope.invoiceData.bankAccount.specSym == undefined) {
                    //nevalidni vstup
                    $scope.symbolValidator = true;
                    $scope.symbolValidatorMsg.push("Specifický symbol není validní. (Pouze číslice)");
                } else {
                    if ($scope.invoiceData.bankAccount.specSym != null) {
                        //nejaky vstup validni
                        var testVariableSym = $scope.invoiceData.bankAccount.specSym + "";
                        if (testVariableSym.length > 10) {
                            //moc dlouhy
                            $scope.symbolValidator = true;
                            $scope.symbolValidatorMsg.push("Specifický symbol má maximální délku 10.");
                        }
                    }
                }
            }

            if (($scope.invoiceData.payDate == undefined) || ($scope.invoiceData.payDate == "")){
                $scope.customValidator = true;
                $scope.customValidatorMsg.push("Zadejte datum splatnosti");
            }

            
            if ($scope.invoiceData.items.length == 0)
            {
                $scope.customValidator = true;
                $scope.customValidatorMsg.push("Faktura neobsahuje žádné položky.");
            }

            if (($scope.invoiceData.customerId == undefined) || ($scope.invoiceData.customerId == "") ||
                ($scope.invoiceData.vendorId == undefined) || ($scope.invoiceData.vendorId == ""))
            {
                $scope.customValidator = true;
                $scope.customValidatorMsg.push("Zvolte fakturační údaje firem.");
            }

            if (
                ($scope.InvoiceNumberValidator) &&
                (!$scope.currentCustomerValidator) &&
                (!$scope.currentCustomerBankValidator) &&
                (!$scope.symbolValidator) &&
                (!$scope.customValidator)
                ) {
                confirmModalFactory('md', function () {
                    invoiceService.save($scope.invoiceData,
                        function () {
                            $location.path('/app/financeMenu')
                        },
                        function (err) {
                            $scope.customValidator = true;
                            $scope.customValidatorMsg.push("Došlo k chybě.");
                            $scope.customValidatorMsg.push(err.data.message);
                        }
                    );
                });
            }
            

            
            /*
            invoiceService.save($scope.invoiceData,
                function () {
                    $location.path('/app/financeMenu')
                },
                function () {
                }
            );*/
        };

        $scope.loadVendorList = function () {
            vendorService.getAll(
            function (data) {
                $scope.vendorList = data.plain();
                $scope.customerList = data.plain();
                console.log(data.plain());
            },
            function () { });
        }
        $scope.loadVendorList();

        $scope.changeCustomer = function ()
        {
            console.log($scope.currentCustomer);

            $scope.currentCustomerValidator = false;
            $scope.currentCustomerBankValidator = false;
            $scope.invoiceData.payType = 0;
            
            $scope.invoiceData.customer.id = $scope.currentCustomer.id;
            $scope.invoiceData.customer.name = $scope.currentCustomer.name;
            $scope.invoiceData.customer.ic = $scope.currentCustomer.ico;
            $scope.invoiceData.customer.dic = $scope.currentCustomer.dic;
            $scope.invoiceData.customer.street = $scope.currentCustomer.addresModel.street + " " + $scope.currentCustomer.addresModel.cp;
            $scope.invoiceData.customer.city = $scope.currentCustomer.addresModel.city;
            $scope.invoiceData.customer.zipCode = $scope.currentCustomer.addresModel.psc;
            $scope.invoiceData.customer.email = $scope.currentCustomer.contactModel.email;
            $scope.invoiceData.customer.tel = $scope.currentCustomer.contactModel.phoneNumber;

            if ($scope.currentCustomer.bankAccountId > 0) {
                $scope.invoiceData.bankAccount.numberPrefix = $scope.currentCustomer.bankAccountModel.numberPrefix;
                $scope.invoiceData.bankAccount.number = $scope.currentCustomer.bankAccountModel.number;
                $scope.invoiceData.bankAccount.bankCode = $scope.currentCustomer.bankAccountModel.bankCode;
                $scope.invoiceData.bankAccount.SWIFT = $scope.currentCustomer.bankAccountModel.swift;
                $scope.invoiceData.bankAccount.IBAN = $scope.currentCustomer.bankAccountModel.iban;
            } else {
                //vytvorit kontakt
            }
        }

        $scope.changeVendor = function () {
            console.log($scope.currentVendor);
            console.log($scope.currentVendor.addresModel);
            $scope.invoiceData.vendor.id = $scope.currentVendor.id;
            $scope.invoiceData.vendor.name = $scope.currentVendor.name;
            $scope.invoiceData.vendor.ic = $scope.currentVendor.ico;
            $scope.invoiceData.vendor.dic = $scope.currentVendor.dic;
            $scope.invoiceData.vendor.street = $scope.currentVendor.addresModel.street + " " + $scope.currentVendor.addresModel.cp;
            $scope.invoiceData.vendor.city = $scope.currentVendor.addresModel.city;
            $scope.invoiceData.vendor.zipCode = $scope.currentVendor.addresModel.psc;
            $scope.invoiceData.vendor.email = $scope.currentVendor.contactModel.email;
            $scope.invoiceData.vendor.tel = $scope.currentVendor.contactModel.phoneNumber;
        }

        $scope.cancel = function () {
            window.history.back();
        }

        $scope.addItem = function () {
            var data = $scope.dataItem;
            if (!!data.desc && 
                !!data.count &&
                !!data.price && 
                !!(+data.price)) {
                $scope.invoiceData.items.push(data);

                //clear
                $scope.dataItem = {
                    desc: "",
                    count: "",
                    price: "",
                }
            }
        }
    }
);