﻿'use strict'

//controller for html body

dpApp.controller('startAppController', 
    function ($scope, $rootScope, soilBlockService, crpService, invoiceService, costPlanService) {

        console.log("sart app call controller");
        $scope.globalCurrentDateFrom = new Date();
        $scope.globalCurrentDateTo = new Date(new Date().setMonth(new Date().getMonth() + 1));
        
        
        

        $scope.loadSoilBlockData = function () {
            $scope.existSoilBlock = false;
            $scope.soilBlockBaseInfo = {
                countSoilBlock: 0,
                countPartSoilBlock: 0,
                totalArea: 0
            };

            console.log("start app year " + $rootScope.globalMarketingYear);

            soilBlockService.soilBlockInfo($rootScope.globalMarketingYear,
                function (data) {
                    if (data.length > 0) {
                        //$scope.soilBlockTable = data;
                        console.log("info soil block");
                        console.log(data.plain());
                        $scope.existSoilBlock = true;
                        angular.forEach(data.plain(), function (block) {
                            $scope.soilBlockBaseInfo.countSoilBlock += 1;
                            $scope.soilBlockBaseInfo.countPartSoilBlock += block.countPartsSoilBlocks;
                            $scope.soilBlockBaseInfo.totalArea += block.area;
                        });
                    }
                }, function (err) {
                    console.log(err);
                });
        };
        $scope.loadSoilBlockData();

        $scope.loadActualCropStatus = function () {
            crpService.getActualCropStatus($rootScope.globalMarketingYear,
                function (data) {
                    $scope.actualCropStatus = data.plain();
                },
                function (err) {
                    console.log("load actual crop status error");
                    console.log(err);
                });
        };
        $scope.loadActualCropStatus();

        $scope.loadStockMaterialAlarm = function () {
            crpService.stockMaterialAlarm($rootScope.globalMarketingYear,
                function (data) {
                    $scope.stockMaterialAlarmData = data.plain();
                },
                function (err) {
                    console.log("load stock material alarm error");
                    console.log(err);
                });
            crpService.stockFuelAlarm($rootScope.globalMarketingYear,
                function (data) {
                    $scope.stockFuelAlarmData = data.plain();
                },
                function (err) {
                    console.log("load stock fuel alarm error");
                    console.log(err);
                });
        };
        $scope.loadStockMaterialAlarm();

        $rootScope.$on("updateDataChangeMarketingYear", function (e) {
            $scope.loadSoilBlockData();
            $scope.loadActualCropStatus();
            $scope.loadStockMaterialAlarm();
        });

        $scope.loadGlobalInvoiceList = function () {
            invoiceService.getFalseStateInvoices($scope.globalCurrentDateFrom, $scope.globalCurrentDateTo,
                function (data) {
                    console.log("all invoices records");
                    console.log(data.plain());
                    $scope.invoicesGlobalTable = data.plain();
                },
                function () { });
        }
        $scope.loadGlobalInvoiceList();

        $scope.loadWorkPlan = function () {
            var obj = {
                From: $scope.globalCurrentDateFrom,
                To: $scope.globalCurrentDateTo,
                Type: 0
            };
            costPlanService.loadWorkPlan(obj,
                function (data) {
                    console.log("work plan data");
                    console.log(data.plain());
                    $scope.workPlanGlobalTable = data.plain();
                },
                function (err) {
                    console.log("load work plan error", err);
                });
        };
        $scope.loadWorkPlan();


    });