﻿//crop rotation plan service
dpApp.service('crpService', ['Restangular',
    function (Restangular) {
        this.create = function (crpData, costData, success, fail) {
            Restangular.all('crp').post(crpData).then(function (crpId)
            {
                console.log("crp id " + crpId);
                console.log(costData);
                angular.forEach(costData,
                    function (costPlanItem)
                    {
                        console.log("ukladam polozku");
                        
                        costPlanItem.CrpId = crpId;
                        console.log(costPlanItem);
                        Restangular.all('costPlan').post(costPlanItem).then(success, fail);
                    });
                
            }, fail);
        }

        this.getAll = function (success, fail) {
            Restangular.all('crp').getList().then(success, fail);
        };

        this.getCrpInfo = function (year, success, fail) {
            Restangular.all('crp').one('all', year).get(year).then(success, fail);
        }

        this.getById = function (id, success, fail) {
            Restangular.all('crp').get(id).then(success, fail);
        }

        this.getByYearPartSoilBlockId = function (year, partSoilBlockId, success, fail) {
            console.log(year, partSoilBlockId);
            Restangular.all('crp').one('getBy', year).one('part', partSoilBlockId).get().then(success, fail);
        };

        this.getActualCropStatus = function (year, success, fail) {
            Restangular.all('crp').one('actualCropStatus', year).get().then(success, fail);
        };

        this.stockMaterialAlarm = function (year, success, fail) {
            Restangular.all('crp').one('stockMaterialAlarm', year).get().then(success, fail);
        };

        this.stockFuelAlarm = function (year, success, fail) {
            Restangular.all('crp').one('stockFuelAlarm', year).get().then(success, fail);
        };

        this.finishCrpItem = function (data, success, fail) {
            var updateCostPlanItem = null
            var updateMaterial = null;
            var updateFuel = null;
            var updateMachinery = null;

            var updateCrp = null;
            var updateSoilBlock = null;
            var updateData = data;

            var objectBusinessRecordMaterial = null;
            var objectBusinessRecordFuel = null;

            console.log("servisa ma data");
            Restangular.all('costPlan').get(data.CrpItemId).then(
                function (data) {
                    console.log("crpItem");
                    console.log(data.plain());
                    updateCostPlanItem = data.plain();
                    updateMaterial = updateCostPlanItem.stockItem;
                    updateFuel = updateCostPlanItem.fuelItem;
                    updateMachinery = updateCostPlanItem.machinery;

                    Restangular.all('crp').get(updateCostPlanItem.crpId).then(
                        function (data) {
                            console.log("crp");
                            console.log(data.plain());

                            updateCrp = data.plain();
                            updateSoilBlock = updateCrp.partSoilBlock.soilBlock;

                            //data ready
                            
                            updateCostPlanItem.actualCosts = updateData.realCost;
                            updateCostPlanItem.status = true;
                            console.log("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
                            console.log(updateCostPlanItem);
                            console.log(updateData.DateApplicationString);
                            updateCostPlanItem.DateApplicationString = updateData.DateApplicationString;
                            console.log("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");

                            updateMaterial.price = Number(updateMaterial.price) - Number(updateData.materialCost);
                            updateMaterial.quantity = Number(updateMaterial.quantity) - Number(updateData.materialQuantity);

                            updateFuel.price = Number(updateFuel.price) - Number(updateData.fuelCost);
                            updateFuel.quantity = Number(updateFuel.quantity) - Number(updateData.fuelQuantity);

                            updateMachinery.hours = Number(updateMachinery.hours) + Number(updateData.machineryHour);

                            console.log(updateCrp);
                            console.log("vypocet nakladu");
                            console.log(Number(updateCrp.realCost) + " + " + Number(updateData.RealCost) + " = " + (Number(updateCrp.realCost) + Number(updateData.RealCost)));
                            updateCrp.RealCost = Number(updateCrp.realCost) + Number(updateData.RealCost);
                            
                            console.log("update crop rotation plan");
                            console.log(updateCrp);

                            updateSoilBlock.n = Number(updateSoilBlock.n) + Number(updateCostPlanItem.n);
                            updateSoilBlock.s = Number(updateSoilBlock.s) + Number(updateCostPlanItem.s);
                            updateSoilBlock.p = Number(updateSoilBlock.p) + Number(updateCostPlanItem.p);
                            updateSoilBlock.k = Number(updateSoilBlock.k) + Number(updateCostPlanItem.k);
                            //data for update
                            objectBusinessRecordMaterial = {
                                name: updateMaterial.name,
                                description: updateMaterial.description,
                                price: updateData.materialCost,//
                                quantity: updateData.materialQuantity,//
                                categoryId: updateMaterial.categoryId,
                                MeasureId: updateMaterial.measureId,
                                StockItemId: updateMaterial.id,
                                VendorId: 1, // vlastni spotreba
                                Income: false
                            }

                            objectBusinessRecordFuel = {
                                name: updateFuel.name,
                                description: updateFuel.description,
                                price: updateData.fuelCost,//
                                quantity: updateData.fuelQuantity,//
                                categoryId: updateFuel.categoryId,
                                MeasureId: updateFuel.measureId,
                                StockItemId: updateFuel.id,
                                VendorId: 1, // vlastni spotreba
                                Income: false
                            }

                            //update in db updateCostPlanItem
                            Restangular.all('costPlan').post(updateCostPlanItem).then(
                            function () {

                                if (updateMaterial.id > 0) { 
                                //update in db material
                                Restangular.all('stock').post(updateMaterial).then(
                                function () {
                                    Restangular.all('businessRecord').post(objectBusinessRecordMaterial).then(function () { }, fail);
                                }, fail);
                                }

                                //update in db fuel
                                Restangular.all('stock').post(updateFuel).then(
                                function () {
                                    Restangular.all('businessRecord').post(objectBusinessRecordFuel).then(function () { }, fail);
                                }, fail);

                                //update in db crp
                                Restangular.all('crp').post(updateCrp).then(
                                function () {
                                    Restangular.all('SoilBlock').post(updateSoilBlock).then(
                                        function () {
                                            Restangular.all('Machinery').post(updateMachinery).then(success, fail);
                                        }, fail);
                                }, fail);
                                
                            }, fail);
                            
                            



                            
                        }, fail);//crp

                }, fail);//crpItem

            

            
        }

    }
]);