﻿using business;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Repositories;
using Data.Attributes;

namespace bussines.Services
{
    public class CostPlanService : BaseService<CostPlan>
    {
        public async Task<IEnumerable<CostPlan>> GetAllCrp(long crpId)
        {
            return await Repository.GetAllCrp(crpId);
        }

        public async Task<IEnumerable<WorkPlan>> GetWorkPlan(long companyId, string from, string to, bool type)
        {
            DateTime _from = DateTime.ParseExact(from.Split('T')[0], "yyyy-MM-dd", System.Globalization.CultureInfo.InvariantCulture);
            DateTime _to = DateTime.ParseExact(to.Split('T')[0], "yyyy-MM-dd", System.Globalization.CultureInfo.InvariantCulture);
            return await Repository.LoadWorkPlan(companyId, _from, _to, type);
        }
    }
}
