﻿using business;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Repositories;
using Data.Attributes;
using Data.Enums;

namespace bussines.Services
{
    public class CropRotationPlanService : BaseService<CropRotationPlan>
    {
        public Task<CropRotationPlan> GetCrpByPartId(long partSoilBlockId)
        {
            return Repository.GetCrpByPartId(partSoilBlockId);
        }

        public Task<IEnumerable<CropRotationPlan>> GetPlansByYear(long year, long companyId)
        {
            return Repository.GetPlansByYear(year, companyId);
        }

        public Task<IEnumerable<CropRotationPlan>> GetPlansByYearPartSoilBlockId(long year, long partSoildBlockId)
        {
            return Repository.GetPlansByYear(year, partSoildBlockId);
        }

        public Task<IEnumerable<ActualCropStatus>> ActualCropStatus(long year, long companyId)
        {
            return Repository.ActualCropStatus(year, companyId);
        }

        public async Task<IEnumerable<StockAlarmItem>> StockMaterialAlarm(long year, long companyId)
        {
            List<StockAlarmItem> stockAlarm = new List<StockAlarmItem>();
            StockItemService stockService = new StockItemService();
            var crpData = Repository.UseQuantity(year, companyId).Result;
            foreach (var item in crpData) {
                var testItem = stockService.GetById(item.StockId).Result;
                if (item.NeedQuantity > testItem.Quantity) {
                    item.StockState = testItem.Quantity;
                    item.NeedQuantity -= testItem.Quantity;
                    item.Measure = Enum.GetName(typeof(Measure), item.MeasureId);
                    stockAlarm.Add(item);
                }
            }
            return await Task.FromResult(stockAlarm); 
        }

        public async Task<IEnumerable<StockAlarmFuel>> StockFuelAlarm(long year, long companyId)
        {
            List<StockAlarmFuel> stockAlarm = new List<StockAlarmFuel>();
            StockItemService stockService = new StockItemService();
            var crpData = Repository.UseFuel(year, companyId).Result;
            foreach (var item in crpData) {
                var testItem = stockService.GetById(item.FuelId).Result;
                if (item.Consuption > testItem.Quantity)
                {
                    item.StockState = testItem.Quantity;
                    item.Consuption -= testItem.Quantity;
                    item.MeasureName = Enum.GetName(typeof(Measure), item.MeasureId);
                    stockAlarm.Add(item);
                }
            }
            return await Task.FromResult(stockAlarm); 
        }
    }
}
