﻿using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Repositories;

namespace bussines.Services
{
    public class InvoiceService : BaseService<Invoice>
    {
        public async Task<long> GetLastInvoiceNumber(long companyId)
        {
            return await Task.FromResult(Repository.GetLastInvoiceNumber(companyId).Result);
        }

        public async Task<bool> CheckInvoiceNumber(long invoiceNumber, long companyId)
        {
            return await Task.FromResult(Repository.CheckInvoiceNumber(invoiceNumber, companyId).Result);
        }

        public async Task<long> CreateNewInvoice(Invoice invoiceData, BankAccount bankData, string constantSym, string variableSym, string specSym) 
        {
            if (invoiceData.PayType)
            {
                //prevod
                BankTransactionService TransactionService = new BankTransactionService();
                string _constSym = "0000";
                string _variableSym = "0000000000";
                string _specSym = "0000000000";
                if (constantSym != "") { _constSym = constantSym;  }
                if (variableSym != "") { _variableSym = variableSym; }
                if (specSym != "") { _specSym = specSym; }
                var transactionData = new BankTransaction
                {
                    BankAccountNumber = bankData.NumberPrefix + " - " + bankData.Number + " / " + bankData.BankCode,
                    VariableSym = _variableSym,
                    ConstSym = _constSym,
                    SpecSym = _specSym
                };
                var transactionId = TransactionService.Put(transactionData).Result;
                invoiceData.BankTransactionId = transactionId;
                return await Task.FromResult(this.Put(invoiceData).Result);
            }
            else 
            {
                //hotove
                return await Task.FromResult(this.Put(invoiceData).Result);
            }
        }

        public async Task<bool> ChangePayState(long invoiceId, bool type)
        {
            return await Task.FromResult(Repository.ChangePaySate(invoiceId, type).Result);
        }

        public async Task<IEnumerable<Invoice>> GetAllFalseInvoices(long companyId, string from, string to)
        {
            DateTime _from = DateTime.ParseExact(from.Split('T')[0], "yyyy-MM-dd", System.Globalization.CultureInfo.InvariantCulture);
            DateTime _to = DateTime.ParseExact(to.Split('T')[0], "yyyy-MM-dd", System.Globalization.CultureInfo.InvariantCulture);
            return await Task.FromResult(Repository.GetFalseInvoices(companyId, _from, _to).Result);

        }
    }
}
