﻿using business;
using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Repositories;

namespace bussines.Services
{
    public class SoilBlockService : BaseService<SoilBlock>
    {

        public async Task<IEnumerable<PartSoilBlock>> PutAndGetParts(SoilBlock model, int partsCount)
        {
            var partSoilBlockService = new PartSoilBlockService();

            var idNewSoilBlock = base.Put(model).Result;

            for (int i = 0; i < partsCount; i++)
            {
                await partSoilBlockService.Put(
                    new PartSoilBlock
                    {
                        CreatedAt = DateTime.UtcNow,
                        MarketingYear = DateTime.UtcNow.Year,
                        SoilBlockId = idNewSoilBlock,
                        Description = "test"
                    });
            }

            return await partSoilBlockService.GetBySoilBlock(idNewSoilBlock, DateTime.UtcNow.Year);
        }

        public async Task<Dictionary<long, int>> GetBlocksPartsCount(IEnumerable<long> ids, long year)
        {
            return await Repository.GetBlocksPartCount(ids, year);
        }

        public override async Task Delete(long id)
        {
            var partService = new PartSoilBlockService();
            await partService.DeleteByBlock(id);
            await base.Delete(id);
        }
    }
}