﻿using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Data.Repositories;
using Data.Enums;

namespace bussines.Services
{
    public class StockItemService : BaseService<StockItem>
    {
        public async Task<long> PutStockItemWithRelation(StockItem model, int[] cropRelation)
        {
            var cropRelationshipService = new CropRelationshipService();

            var idnewStockItem = base.Put(model).Result;

            foreach(int cropId in cropRelation){
                await cropRelationshipService.Put(
                    new CropRelationship
                    {
                        CompanyId = model.CompanyId,
                        CropId = cropId,
                        StockItemId = idnewStockItem
                    });
            }

            return idnewStockItem;
            

        }

        public async Task<IEnumerable<StockItem>> GetAllCategory(long idCategory, long CompanyId)
        {
            return await Repository.GetAllCategory(idCategory, CompanyId);
        }

        public async Task<IEnumerable<StockItem>> GetCategoryByRelation(long idCategory,long idRelation)
        {
            return await Repository.GetCategoryByRelation(idCategory, idRelation);
        }

        public async Task<IEnumerable<StockStatus>> GetStockStatus(long CompanyId)
        {
            return await Repository.GetStockStatus(CompanyId);
        }
    }
}
