﻿using Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bussines.Validators
{
    public class BankAccountValidator : IValidator<BankAccount>
    {
        public IEnumerable<string> Validate(BankAccount model)
        {
            List<string> errors = new List<string>();

            if (!model.IsForeign &&
                (string.IsNullOrEmpty(model.Number) || string.IsNullOrEmpty(model.BankCode)))
            {
                errors.Add("Informace o bankovním účtu jsou neúplné.");
                return errors;
            }

            if (model.BankCode.Length != 4)
            {
                errors.Add("Kód banky má špatný formát.");
            }

            return errors;
        }
    }
}
